import javax.swing.event.MouseInputAdapter;
import java.awt.Point;
import java.awt.event.MouseEvent;
import java.awt.event.KeyEvent;
import java.awt.event.MouseMotionListener;

public class FieldMouseInputAdapter extends MouseInputAdapter implements MouseMotionListener{
    FormationEditor f;


    // Stupid pong idea
    public void mouseMoved(MouseEvent e){
	if (f == null) f = FormationEditor.instance;

	Point p = e.getPoint();
	p.translate((int)(-f.PITCH_MARGIN), (int)(-f.PITCH_MARGIN));
	p.translate((int)(-f.PITCH_LENGTH/2*f.ZOOM),
		    (int)(-f.PITCH_WIDTH/2*f.ZOOM));
	Pong.setYforHumanPaddle(p.getY()/f.ZOOM);
    }

    public void mousePressed(MouseEvent e){
	if (f == null) f = FormationEditor.instance;
	if (f.p != null && f.p.isAlive()) return;
	f.field.requestFocus();

	double g = f.gridSize;
	Point p = e.getPoint();
	p.translate((int)(-f.PITCH_MARGIN), (int)(-f.PITCH_MARGIN));
	double x = p.getX()/f.ZOOM-f.PITCH_LENGTH/2;
	double y = p.getY()/f.ZOOM-f.PITCH_WIDTH /2;
	if (!f.mode.equals("ball") && f.pressedKeyCodeOnField != -1){
	    Vector2D v;
	    Player pp;
	    if (f.mode.equals("home")){
		pp = f.aF.getPlayerWithClosestHomePositionTo(new Vector2D(x, y));
		if (pp == null) return;
		x = f.aF.player[f.activePlayer].homePosition.getX();
		y = f.aF.player[f.activePlayer].homePosition.getY();
	    }else{
		pp = f.aF.getPlayerWithClosestInitPositionTo(new Vector2D(x, y));
		if (pp == null) return;
		x = f.aF.player[f.activePlayer].initPosition.getX();
		y = f.aF.player[f.activePlayer].initPosition.getY();
	    }
	    if (f.pressedKeyCodeOnField == KeyEvent.VK_ALT){
		if (f.mode.equals("home")) x = pp.homePosition.getX();
		else                      x = pp.initPosition.getX();
	    }else
	    if (f.pressedKeyCodeOnField == KeyEvent.VK_CONTROL){
		if (f.mode.equals("home")) y = pp.homePosition.getY();
		else                      y = pp.initPosition.getY();
	    }
	}else{
	}
	if (g > 0){
	    x = Math.round(x / g) * g;
	    y = Math.round(y / g) * g;
	}
	x = Math.rint(x*100)/100;
	y = Math.rint(y*100)/100;
	if (Math.abs(x) > f.PITCH_LENGTH/2 ||
	    Math.abs(y) > f.PITCH_WIDTH /2  )
	    return;
	if (f.toChange.equals("pos")){
	    if (f.mode.equals("init") && x > 0) return;
	    //System.out.println("Neue Position: ("+ x +","+ y +")");
	    if (f.mode.equals("init")){
		f.aF.player[f.activePlayer].initPosition.setX(x);
		f.aF.player[f.activePlayer].initPosition.setY(y);
	    }
	    if (f.mode.equals("home")){
		f.aF.player[f.activePlayer].homePosition.setX(x);
		f.aF.player[f.activePlayer].homePosition.setY(y);
	    }
	    if (f.mode.equals("ball")){
		f.ballPos.setX(x);
		f.ballPos.setY(y);
	    }
	}
	if (f.toChange.equals("min")){
	    if (x < f.aF.player[f.activePlayer].maxX)
		f.aF.player[f.activePlayer].minX = x;
	}
	if (f.toChange.equals("max")){
	    if (x > f.aF.player[f.activePlayer].minX)
		f.aF.player[f.activePlayer].maxX = x;
	}
	f.field.repaint();
	f.jt.repaint();
    }
}
