import java.io.*;

public class Formation implements Serializable{
    public Player player[];
    public String name;
    public int id;

    public Object clone(){
	return new Formation(player, name, id);	
    }

    public Formation(){
	player = new Player[11];
	for (int i=0; i < 11; i++)
	    player[i] = new Player(i+1);
	name = "new Formation";
	id = -1;
    }
    public Formation(Player p[], String name, int id){
	player = new Player[11];
	for (int i = 0; i < 11; i++){
	    player[i] = (Player)p[i].clone();
	}
	this.name = name;
	this.id = id;	
    }
    public Player getPlayerWithClosestHomePositionTo(Vector2D v){
	Player closest = null;
	double distance = 10000;
	for(int i = 0; i < 11; i++){
	    if (i == FormationEditor.instance.activePlayer) continue;
	    double d = player[i].homePosition.distanceTo(v);
	    if ( d < distance){
		closest = player[i];
		distance = d;
	    }
	}
	return closest;
    }
    public Player getPlayerWithClosestInitPositionTo(Vector2D v){
	Player closest = null;
	double distance = 10000;
	for(int i = 0; i < 11; i++){
	    if (i == FormationEditor.instance.activePlayer) continue;
	    double d = player[i].initPosition.distanceTo(v);
	    if ( d < distance){
		closest = player[i];
		distance = d;
	    }
	}
	return closest;
    }
    public String getHomeXText(){
	String t = "";
	for (int i = 0; i < 11; i++) t += player[i].homePosition.getX() +"  ";	
	return t;
    }
    public String getHomeYText(){
	String t = "";
	for (int i = 0; i < 11; i++) t += player[i].homePosition.getY() +"  ";	
	return t;
    }
    public String getInitXText(){
	String t = "";
	for (int i = 0; i < 11; i++) t += player[i].initPosition.getX() +"  ";	
	return t;
    }
    public String getInitYText(){
	String t = "";
	for (int i = 0; i < 11; i++) t += player[i].initPosition.getY() +"  ";	
	return t;
    }
    public String getBehaveText(){
	String t = "";
	for (int i = 0; i < 11; i++) t += (player[i].type+1) +"  ";	
	return t;
    }
    public String getBehaveTextUvA(){
	String t = "";
	for (int i = 0; i < 11; i++) t += (player[i].type) +"  ";	
	return t;
    }
    public String getAttrXText(){
	String t = "";
	for (int i = 0; i < 11; i++) t += player[i].attrX +"  ";	
	return t;
    }
    public String getAttrXTextUvA(){
	String t = "";
	double attrx[] = new double[9];
	for(int i = 0; i < 11; i++){
	    attrx[player[i].type] = player[i].attrX;
	}
	for (int i = 0; i < 9; i++) t += attrx[i] +"  ";	
	return t;
    }
    public String getAttrYText(){
	String t = "";
	for (int i = 0; i < 11; i++) t += player[i].attrY +"  ";	
	return t;
    }
     public String getAttrYTextUvA(){
	String t = "";
	double attry[] = new double[9];
	for(int i = 0; i < 11; i++){
	    attry[player[i].type] = player[i].attrY;
	}
	for (int i = 0; i < 9; i++) t += attry[i] +"  ";	
	return t;
    }
   public String getMinXText(){
	String t = "";
	for (int i = 0; i < 11; i++) t += player[i].minX +"  ";	
	return t;
    }
     public String getMinXTextUvA(){
	String t = "";
	double minx[] = new double[9];
	for(int i = 0; i < 11; i++){
	    minx[player[i].type] = player[i].minX;
	}
	for (int i = 0; i < 9; i++) t += minx[i] +"  ";	
	return t;
    }
    public String getMaxXText(){
	String t = "";
	for (int i = 0; i < 11; i++) t += player[i].maxX +"  ";	
	return t;
    }
     public String getMaxXTextUvA(){
	String t = "";
	double maxx[] = new double[9];
	for(int i = 0; i < 11; i++){
	    maxx[player[i].type] = player[i].maxX;
	}
	for (int i = 0; i < 9; i++) t += maxx[i] +"  ";	
	return t;
    }
    public String getBeBaText(){
	String t = "";
	for (int i = 0; i < 11; i++) t += (player[i].behindBall ? "1" : "0") +"  ";	
	return t;
    }
     public String getBeBaTextUvA(){
	String t = "";
	boolean beba[] = new boolean[9];
	for(int i = 0; i < 11; i++){
	    beba[player[i].type] = player[i].behindBall;
	}
	for (int i = 0; i < 9; i++) t += (beba[i] ? "1" : "0") +"  ";	
	return t;
    }
}



