import java.io.*;
    public class Player extends MovingObject implements Serializable{
	public Vector2D homePosition;
	public Vector2D initPosition;
	public Vector2D position_re;
	public int   unum;
	public int   type; // behaviour
	public boolean goalie;
	public int   playerType;
	public double attrX = 0, attrY = 0;
	public double minX = 0, maxX = 0;
	public boolean behindBall = false;
	public double bodyDir;
	public double headDir;
	public void print(){
	    System.out.println("Player\n Unum: "+ unum);
	    System.out.println(" BodyDir: "+ bodyDir);
	    System.out.println(" HeadDir: "+ headDir);
	    super.print();
	}

	public Player(){
	    homePosition = new Vector2D(0,0);
	    initPosition = new Vector2D(0,0);	    
	    position     = new Vector2D(0,0);
	    velocity     = new Vector2D(0,0);
	}
	public Player(int unum){
	    homePosition = new Vector2D(0,0);
	    initPosition = new Vector2D(0,0);	    
	    this.unum = unum;
	    this.type = unum-1;
	}
	public Player(int unum, double y){
	    this.unum = unum;
	    this.type = unum-1;
	    this.homePosition = new Vector2D(-60+(unum*10),-y/2 - 2);
	    this.initPosition = new Vector2D(-60+(unum*10),-y/2 - 2);
	}
	public Vector2D getRealPredictedPosition(Vector2D ballPos){
	    if (position == null) position = (Vector2D)homePosition.clone();
	    Vector2D rBP = new Vector2D(ballPos.getX() - homePosition.getX(),
					ballPos.getY() - homePosition.getY());
	    double x = homePosition.getX() + rBP.getX() * attrX;
	    double y = homePosition.getY() + rBP.getY() * attrY;
	    if (behindBall)
		x = Math.min(x, ballPos.getX());
	    if (Math.abs(y) > 30.0)
		y = (y - 0.5 * attrY * rBP.getY());
	    x = Math.max(minX, x);
	    x = Math.min(maxX, x);
	    return new Vector2D(x,y);
	}
	public Vector2D getRevertedRealPredictedPosition(Vector2D ballPos){
	    if (position_re == null) position_re = (Vector2D)homePosition.revert().clone();
	    Vector2D hP = homePosition.revert();
	    Vector2D rBP = new Vector2D(ballPos.getX() - hP.getX(),
					ballPos.getY() - hP.getY());
	    double x = hP.getX() + rBP.getX() * attrX;
	    double y = hP.getY() + rBP.getY() * attrY;
	    if (behindBall)
		x = Math.max(x, ballPos.getX());
	    if (Math.abs(y) > 30.0)
		y = (y - 0.5 * attrY * rBP.getY());
	    x = Math.min(-minX, x);
	    x = Math.max(-maxX, x);
	    return new Vector2D(x,y);	 
	}
	public Vector2D getPredictedPosition(Vector2D ballPos){
	    if (position == null) position = (Vector2D)homePosition.clone();
	    Vector2D rBP = new Vector2D(ballPos.getX() - homePosition.getX(),
					ballPos.getY() - homePosition.getY());
	    double x = homePosition.getX() + rBP.getX() * attrX;
	    double y = homePosition.getY() + rBP.getY() * attrY;
	    if (behindBall)
		x = Math.min(x, ballPos.getX());
	    if (Math.abs(y) > 30.0)
		y = (y - 0.5 * attrY * rBP.getY());
	    x = Math.max(minX, x);
	    x = Math.min(maxX, x);
	    Vector2D way = ((new Vector2D(x,y)).minus(position));
	    if (way.getLength() > 1)
		position.move(way.withLength(FormationEditor.PLAYER_SPEED));
	    return position;	 
	}
	public Vector2D getRevertedPredictedPosition(Vector2D ballPos){
	    if (position_re == null) position_re = (Vector2D)homePosition.revert().clone();
	    Vector2D hP = homePosition.revert();
	    Vector2D rBP = new Vector2D(ballPos.getX() - hP.getX(),
					ballPos.getY() - hP.getY());
	    double x = hP.getX() + rBP.getX() * attrX;
	    double y = hP.getY() + rBP.getY() * attrY;
	    if (behindBall)
		x = Math.max(x, ballPos.getX());
	    if (Math.abs(y) > 30.0)
		y = (y - 0.5 * attrY * rBP.getY());
	    x = Math.min(-minX, x);
	    x = Math.max(-maxX, x);
	    Vector2D way = ((new Vector2D(x,y)).minus(position_re));	   
	    if (way.getLength() > 1)
		position_re.move(way.withLength(FormationEditor.PLAYER_SPEED));	    
	    return position_re;	 
	}
	public Object clone(){
	    Player p = new Player(unum, 0);
	    p.type = type;
	    p.homePosition = (Vector2D)homePosition.clone();
	    p.initPosition = (Vector2D)initPosition.clone();
	    p.attrX = attrX;
	    p.attrY = attrY;
	    p.minX = minX;
	    p.maxX = maxX;
	    p.behindBall = behindBall;
	    return p;
	}
    }
