import java.awt.geom.*;

// Stupid Pong...
public class Pong extends Thread{
    public static double humanPaddleY = 0;
    public static double compPaddleY = 0;
    public boolean running = false;
    public Vector2D speed;
    FormationEditor fe;
    Rectangle2D.Double humanPaddle, compPaddle;
    public final double maxSpeed = 1.5;
    public int pL, pR;
    public Line2D.Double bL, tL;
    public static int keyPressed = 0;
 
    public Pong(){
	fe = FormationEditor.instance;
	pL = 0;
	pR = 0;
	running = true;
	speed = new Vector2D(1,0);
	humanPaddle = new Rectangle2D.Double( fe.PITCH_LENGTH/2 * fe.ZOOM,
					      -fe.GOAL_LENGTH/2 * fe.ZOOM,
					      fe.GOAL_WIDTH * fe.ZOOM,
					      fe.GOAL_LENGTH * fe.ZOOM);
	compPaddle = new Rectangle2D.Double( (-fe.PITCH_LENGTH/2-fe.GOAL_WIDTH) * fe.ZOOM,
					     -fe.GOAL_LENGTH/2 * fe.ZOOM,
					     fe.GOAL_WIDTH * fe.ZOOM,
					     fe.GOAL_LENGTH * fe.ZOOM);
	tL = new Line2D.Double(-fe.PITCH_LENGTH/2*fe.ZOOM,
			       -fe.PITCH_WIDTH/2*fe.ZOOM,
			       fe.PITCH_LENGTH/2*fe.ZOOM,
			       -fe.PITCH_WIDTH/2*fe.ZOOM);
	bL = new Line2D.Double(-fe.PITCH_LENGTH/2*fe.ZOOM,
			       fe.PITCH_WIDTH/2*fe.ZOOM,
			       fe.PITCH_LENGTH/2*fe.ZOOM,
			       fe.PITCH_WIDTH/2*fe.ZOOM);
    }

    public void destroy(){
	running = false;
    }

    public static void setYforHumanPaddle(double y){
	humanPaddleY = y;	
    }
    public static double getYforHumanPaddle(){
	return humanPaddleY;
    }
    public static Vector2D getBallPos(){
	return FormationEditor.instance.ballPos;
    }
    public void move(){
	Vector2D b = fe.ballPos;
	Vector2D nb = Vector2D.plus(b,speed);
	Line2D.Double l = new Line2D.Double(b.getX()*fe.ZOOM, 
					    b.getY()*fe.ZOOM,
					    nb.getX()*fe.ZOOM,
					    nb.getY()*fe.ZOOM);
	if (l.intersects(humanPaddle) || l.intersects(compPaddle)){
	    speed.setX(speed.getX()*-1.1);	    
	    if (speed.getY() != 0)
		speed.setY(speed.getY()*1.1); // (Math.random() * 0.8 + 0.6));
	    else
		speed.setY(Math.random()*0.4 - 0.2);
	    
	    nb = Vector2D.plus(b,speed);
	    l = new Line2D.Double(b.getX()*fe.ZOOM, 
				  b.getY()*fe.ZOOM,
				  nb.getX()*fe.ZOOM,
				  nb.getY()*fe.ZOOM);
	}
	if (l.intersectsLine(tL) ||
	    l.intersectsLine(bL)){
	    speed.setY(speed.getY()*-1.1);	    	    
	    if (speed.getX() != 0)
		speed.setX(speed.getX()* (Math.random()*0.4 +0.8));
	    else
		speed.setX(Math.random()*0.4 - 0.2);
	}

	fe.ballPos.move(speed);

	if (fe.ballPos.getX() > fe.PITCH_LENGTH/2 + 5){
	    fe.ballPos = new Vector2D();
	    speed = new Vector2D(-1,0);
	    pL++;
	}
	if (fe.ballPos.getX() < -fe.PITCH_LENGTH/2 - 5){
	    fe.ballPos = new Vector2D();
	    speed = new Vector2D(1,0);
	    pR++;
	}
	// Paddle bewegen
	double dist = humanPaddleY - humanPaddle.getY()/fe.ZOOM;
	if (Math.abs(dist) > maxSpeed){
	    dist *= maxSpeed/Math.abs(dist);
	}
	humanPaddle.setRect(humanPaddle.getX(),
			    humanPaddle.getY() + dist*fe.ZOOM,
			    humanPaddle.getWidth(),
			    humanPaddle.getHeight());
	if (keyPressed > 0)
	    compPaddle.setRect(compPaddle.getX(),
			       compPaddle.getY() + maxSpeed*fe.ZOOM,
			       compPaddle.getWidth(),
			       compPaddle.getHeight());
	if (keyPressed < 0)
	    compPaddle.setRect(compPaddle.getX(),
			       compPaddle.getY() - maxSpeed*fe.ZOOM,
			       compPaddle.getWidth(),
			       compPaddle.getHeight());
    }
    public void run(){
	long time, sl;
	while(running){	    
	    FormationEditor.instance.field.repaint();
	    time = System.currentTimeMillis();
	    move();	
	    sl = 40 - (System.currentTimeMillis() - time);
	    if (sl > 0)
		try{ sleep(sl); }catch( Exception e ){}
	}
    }
}
