import java.io.*;

public class Vector2D implements Serializable{
    public double x, y;
    public float  confidence;
    public Vector2D(){ x = 0; y = 0; confidence = 0; }
    public Vector2D(double x, double y){
	this.x = x; this.y = y;
	confidence = 0;
    }
    public double getX(){ return x; }
    public double getY(){ return y; }
    public void setX(double x){ this.x = x; }
    public void setY(double y){ this.y = y; }	
    public Object clone(){
	return new Vector2D(x,y);
    }
    public double distanceTo(Vector2D v){
	double dx = v.getX() - x;
	double dy = v.getY() - y;
	return (Math.sqrt(Math.pow(dx,2) + Math.pow(dy,2)));
    }
    public void move(Vector2D v){
	x += v.x;
	y += v.y;
    }
    public static Vector2D plus(Vector2D v1, Vector2D v2){
	return new Vector2D(v1.x+v2.x, v1.y+v2.y);
    }
    public Vector2D revert(){
	return new Vector2D(-x,-y);
    }
    public Vector2D minus(Vector2D v){
	return new Vector2D(this.x - v.x, this.y - v.y);
    }
    public Vector2D multiply(double d){
	return new Vector2D(x*d, y*d);
    }
    public void widen(double d){
	x *= d;
	y *= d;
    }
    public double getLength(){
	return Math.sqrt(x*x + y*y);
    }
    public void setLength(double d){
	widen(d/getLength());
    }
    public Vector2D withLength(double d){
	return multiply(d/getLength());
    }

    public void print(String s){
	System.out.println(s + "("+x+","+y+"), Confidence: "+ confidence);
    }
}
