import javax.swing.*;
import javax.swing.table.*;

public class WorldModelTableModel extends AbstractTableModel{
    FormationEditor f;

    public int getColumnCount() { return 23; }
    public int getRowCount()    { return 11;}
    public Object getValueAt(int row, int col) { 
	if (f == null) f = FormationEditor.instance;

	float q = f.rotateView ? -1 : 1;

	if (col == 22){ // BALL
	    Ball b = f.activeWorldModel.ball;
	    switch(row){	       
	    case 0: return " ";
	    case 1: return new Double(b.position.x * q);
	    case 2: return new Double(b.position.y * q);
	    case 3: return new Float(b.position.confidence);
	    case 4: return new Double(b.velocity.x * q);
	    case 5: return new Double(b.velocity.y * q); 
	    case 6: return new Float(b.velocity.confidence);
	    default: 
		return "?";
	    }
	}

	if (f.activeWorldModel             == null) return "-";
	if (f.activeWorldModel.left        == null) return "-";
	if (f.activeWorldModel.left.player == null) return "-";
	int unum = col%11+1;
	Player p;
	try{
	    if (col < 11) p = (Player)(f.activeWorldModel.left.player.get(col));
	    else          p = (Player)(f.activeWorldModel.right.player.get(col%11));
	}catch(IndexOutOfBoundsException ioobe){
	    p = null;
	}
	if (p == null) return "-";
	if (row >= 0 && row <= 3 && p.position == null) return "?";
	if (row >= 3 && row <= 5 && p.velocity == null) return "?";
	
	switch(row){
	case  0: return new Integer(p.unum);
	case  1: return new Double(p.position.x * q);
	case  2: return new Double(p.position.y * q);
	case  3: return new Float(p.position.confidence);
	case  4: return new Double(p.velocity.x * q);
	case  5: return new Double(p.velocity.y * q); 
	case  6: return new Float(p.velocity.confidence);
	case  7: return new Double(p.bodyDir);
	case  8: return new Double(p.headDir);
	case  9: return new Integer(p.goalie ? 1 : 0);
        case 10: return new Integer(p.playerType);
	default: 
	    return "?";
	}
    }
    public String getColumnName(int col){
	if (col == 22) return "Ball";
	if (col < 11) return "oT";
	return "tT";
    }
    public void setValueAt(Object n, int row, int col) { 	 
    }
    public boolean isCellEditable(int rowIndex, int columnIndex){
	return false;
    }
}
