/*****************************************************************************
 * ParsedDataProvider.hh
 * Copyright (c) 2001 Virtual Werder
 *
 * implements:
 *   abstract class (interface) ParsedDataProvider
 *
 * requires:
 *   Robocup Client Command Parser lib
 *
 * Created on: 24.10.2002 by wenns
 * Maintainer: wenns
 * Group:
 * Co-authors:
 *
 *
 * $Id: ParsedDataProvider.hh,v 1.2 2004/04/03 20:18:28 harlekin Exp $
 *****************************************************************************/

#ifndef PARSEDDATAPROVIDER_HH
#define PARSEDDATAPROVIDER_HH

#include "SenseObjects.hh"

/** An Interface to access the parsed data */
class ParsedDataProvider {
  public:
    virtual bool getVisual      ( vector<Sense::Line>   *_lines  ,
                                  vector<Sense::Flag>   *_flags  ,
                                  vector<Sense::Goal>   *_goals  ,
                                  vector<Sense::Player> *_allies ,
                                  vector<Sense::Player> *_enemies,
                                  vector<Sense::Player> *_neuts  ,
                                  vector<Sense::Ball>   *_balls  ) = 0;
    virtual bool getFullstate   (Sense::Fullstate     **_fullstate,
                                 vector<Sense::Goal>   *_goals  ,
                                 vector<Sense::Player> *_allies ,
                                 vector<Sense::Player> *_enemies,
                                 vector<Sense::Ball>   *_balls  ) = 0;
    virtual bool getSenseBody   ( Sense::SenseBody    **data ) = 0;
    virtual bool getRefAudio    ( Sense::RefAudio     **data ) = 0;
    virtual bool getSelfAudio   ( Sense::SelfAudio    **data ) = 0;
    virtual bool getPlayerAudio ( Sense::PlayerAudio  **data ) = 0;
    virtual bool getCoachAudio  ( Sense::CoachAudio   **data ) = 0;
    virtual bool getScore       ( Sense::Score        **data ) = 0;
    virtual bool getSubstitution( Sense::Substitution **data ) = 0;
    virtual bool getError       ( Sense::Error        **data ) = 0;
    virtual bool getInitMsg     ( Sense::InitMsg      **data ) = 0;
    virtual bool getServerParam ( Sense::ServerParam  **data ) = 0;
    virtual bool getPlayerParam ( Sense::PlayerParam  **data ) = 0;
    virtual bool getPlayerType  ( Sense::PlayerType   **data ) = 0;
    virtual bool seeReceived()  = 0;
    virtual bool sbReceived()   = 0;
    virtual bool fsReceived()   = 0;
    virtual bool initReceived() = 0;
};

#endif //PARSEDDATAPROVIDER_HH
