/*****************************************************************************
 * SenseThread.hh
 * Copyright (c) 2001 Virtual Werder
 *
 * implements:
 *   namespace SenseThread
 *
 * requires:
 *
 * Created on: 25.03.2001 by wenns
 * Maintainer: cyco
 * Group:
 * Co-authors: wenns
 *
 *
 * $Id: SenseThread.hh,v 1.4 2004/03/25 13:26:07 mosh Exp $
 *****************************************************************************/

#ifndef SENSETHREAD_HH
#define SENSETHREAD_HH

#include "common.hh"

/**
 * This namespace summaries few routines, which are executed in the
 * "sense thread"
 * This functionality isnt implemented in Sensors, in order to avoid that
 * WorldModel ist known by Sensors.
 */
namespace SenseThread{
  /**
   * This function implements the listen loop of the sense-thread. In this infinite
   * loop the messages from the server are received and parsed.
   * @param v pointer to an instance of WorldModel is passed through this parameter
   */
  void *senseCallback(void *v);
  void setTriStep(int step);
  void calculateHoles();
  
};

#endif //SENSETHREAD_HH









