/*******************************************************************************
 * common.cc
 * Copyright (c) 2001 Virtual Werder
 *
 * implements:
 *   some functions
 *
 * requires:
 *
 * Created on: 12.12.2002 by wenns
 * Maintainer: wenns
 * Group:
 * Co-authors:
 *
 * Changelog:
 *
 * $Id: common.cc,v 1.1.1.1 2004/01/30 15:13:41 harlekin Exp $
 *
 ******************************************************************************/

#include <sys/time.h>

#include "common.hh"
#include "debug.hh"

bool isValidAngle(const float ang) { return (ang<=180 && ang>=-180); }
bool isValidBool(const bool b)     { return (b==true || b==false); }
bool isUndefined(const float f) {
  return ((f<(UNDEFINED_FLOAT + EPSILON)) && (f>(UNDEFINED_FLOAT - EPSILON)));
}
bool isUndefined(const int i)       { return (i == UNDEFINED_INT); }


int timerDiffMsec(const struct timeval *minuend,
		  const struct timeval *subtrahend){
  static timeval diff;
  timersub(minuend, subtrahend, &diff);

  return TO_MILLI(diff.tv_sec) + MICRO_TO_MILLI(diff.tv_usec);
}


// $Source: /home/robocup/virtualwerder/CVSRepository/VirtualWerder2004/common.cc,v $
