
/**************************************************************************************
 * debug.hh
 * Copyright (c) 2001 Virtual Werder
 *
 * part of simple client
 *
 * implements:
 *   some macros for debug output that can be removed from the
 *   code completely
 *
 * requires:
 *   <none>
 *
 * Created on: 28.03.2001 by wenns
 * Rewrite on: 2001-10-02 by cyco
 * Maintainer: pagra
 * Group:
 * Co-authors: pagra
 *
 * $Id: debug.hh,v 1.6 2004/05/13 16:28:24 aw Exp $
 *
 *************************************************************************************/

#ifndef DEBUG_HH
#define DEBUG_HH

#include <iostream>
#include "AgentPlanLogger.hh"

using namespace std;

#define ASSERT_DEBUG false    //disabled per default

#include "debugforuser.hh"

#if defined (AGENT_PLAN_LOG_PAGRA)
  #define APL_POINT_PAGRA(p)                   AgentPlanLogger::apl->writePoint(p)
  #define APL_POINT2_PAGRA(p,l)                AgentPlanLogger::apl->writePoint(p,l)
  #define APL_POINT3_PAGRA(p,l,r,g,b)          AgentPlanLogger::apl->writePoint(p,l,r,g,b)
  #define APL_POINT4_PAGRA(p,l,r,g,b,u)        AgentPlanLogger::apl->writePoint(p,l,r,g,b,u)

  #define APL_LINE_PAGRA(p1,p2)                AgentPlanLogger::apl->writeLine(p1,p2)
  #define APL_LINE2_PAGRA(p1,p2,l)             AgentPlanLogger::apl->writeLine(p1,p2,l)
  #define APL_LINE3_PAGRA(p1,p2,l,r,g,b)       AgentPlanLogger::apl->writeLine(p1,p2,l,r,g,b)
  #define APL_LINE4_PAGRA(p1,p2,l,r,g,b,u)     AgentPlanLogger::apl->writeLine(p1,p2,l,r,g,b,u)

  #define APL_POLYLINE_PAGRA(p)                AgentPlanLogger::apl->writePolyLine(p)
  #define APL_POLYLINE2_PAGRA(p,l)             AgentPlanLogger::apl->writePolyLine(p,l)
  #define APL_POLYLINE3_PAGRA(p,l,r,g,b)       AgentPlanLogger::apl->writePolyLine(p,l,r,g,b)
  #define APL_POLYLINE4_PAGRA(p,l,r,g,b,u)     AgentPlanLogger::apl->writePolyLine(p,l,r,g,b,u)

  #define APL_NUMBER_KHUEBNER(p,l,w,h)         AgentPlanLogger::apl->writeNumber(p,l,w,h)
  
  #define APL_ELLIPSE_PAGRA(p,w,h)             AgentPlanLogger::apl->writeEllipse(p,w,h)
  #define APL_ELLIPSE2_PAGRA(p,w,h,l)          AgentPlanLogger::apl->writeEllipse(p,w,h,l)
  #define APL_ELLIPSE3_PAGRA(p,w,h,l,r,g,b)    AgentPlanLogger::apl->writeEllipse(p,w,h,l,r,g,b)
  #define APL_ELLIPSE4_PAGRA(p,w,h,l,r,g,b,u)  AgentPlanLogger::apl->writeEllipse(p,w,h,l,r,g,b,u)

  #define APL_ALLPLAYERS_PAGRA()               AgentPlanLogger::apl->writeAllPlayerPositions()
  #define APL_ALLPLAYERS2_PAGRA(l)             AgentPlanLogger::apl->writeAllPlayerPositions(l)
  #define APL_ALLPLAYERS3_PAGRA(l,c)           AgentPlanLogger::apl->writeAllPlayerPositions(l,c)

  #define APL_BALL_PAGRA()                     AgentPlanLogger::apl->writeBall()
  #define APL_BALL2_PAGRA(l)                   AgentPlanLogger::apl->writeBall(l)
  #define APL_BALL3_PAGRA(l,c)                 AgentPlanLogger::apl->writeBall(l,c)
  
  #define APL_INTERCEPTIONPOINT_PAGRA()        AgentPlanLogger::apl->writeInterceptionPoint()
  #define APL_INTERCEPTIONPOINT2_PAGRA(l)      AgentPlanLogger::apl->writeInterceptionPoint(l)
  #define APL_INTERCEPTIONPOINT3_PAGRA(l,c)    AgentPlanLogger::apl->writeInterceptionPoint(l,c)
 
#else // !AGENT_PLAN_LOG_PAGRA
  #define APL_POINT_PAGRA(p)                   ;
  #define APL_POINT2_PAGRA(p,l)                ;
  #define APL_POINT3_PAGRA(p,l,r,g,b)          ;
  #define APL_POINT4_PAGRA(p,l,r,g,b,u)        ;

  #define APL_LINE_PAGRA(p1,p2)                ;
  #define APL_LINE2_PAGRA(p1,p2,l)             ;
  #define APL_LINE3_PAGRA(p1,p2,l,r,g,b)       ;
  #define APL_LINE4_PAGRA(p1,p2,l,r,g,b,u)     ;

  #define APL_POLYLINE_PAGRA(p)                ;
  #define APL_POLYLINE2_PAGRA(p,l)             ;
  #define APL_POLYLINE3_PAGRA(p,l,r,g,b)       ;
  #define APL_POLYLINE4_PAGRA(p,l,r,g,b,u)     ;

  #define APL_ELLIPSE_PAGRA(p,w,h)             ;
  #define APL_ELLIPSE2_PAGRA(p,w,h,l)          ;
  #define APL_ELLIPSE3_PAGRA(p,w,h,l,r,g,b)    ;
  #define APL_ELLIPSE4_PAGRA(p,w,h,l,r,g,b,u)  ;

  #define APL_ALLPLAYERS_PAGRA()               ;
  #define APL_ALLPLAYERS2_PAGRA(l)             ;
  #define APL_ALLPLAYERS3_PAGRA(l,c)           ;

  #define APL_BALL_PAGRA()                     ;
  #define APL_BALL2_PAGRA(l)                   ;
  #define APL_BALL3_PAGRA(l,c)                 ;

  #define APL_INTERCEPTIONPOINT_PAGRA()        ;
  #define APL_INTERCEPTIONPOINT2_PAGRA(l)      ;
  #define APL_INTERCEPTIONPOINT3_PAGRA(l,c)    ;
 
#endif // AGENT_PLAN_LOG_PAGRA


#if defined (AGENT_PLAN_LOG_MAJUNOR)
  #define APL_POINT_MAJUNOR(p)                   AgentPlanLogger::apl->writePoint(p)
  #define APL_POINT2_MAJUNOR(p,l)                AgentPlanLogger::apl->writePoint(p,l)
  #define APL_POINT3_MAJUNOR(p,l,r,g,b)          AgentPlanLogger::apl->writePoint(p,l,r,g,b)
  #define APL_POINT4_MAJUNOR(p,l,r,g,b,u)        AgentPlanLogger::apl->writePoint(p,l,r,g,b,u)

  #define APL_LINE_MAJUNOR(p1,p2)                AgentPlanLogger::apl->writeLine(p1,p2)
  #define APL_LINE2_MAJUNOR(p1,p2,l)             AgentPlanLogger::apl->writeLine(p1,p2,l)
  #define APL_LINE3_MAJUNOR(p1,p2,l,r,g,b)       AgentPlanLogger::apl->writeLine(p1,p2,l,r,g,b)
  #define APL_LINE4_MAJUNOR(p1,p2,l,r,g,b,u)     AgentPlanLogger::apl->writeLine(p1,p2,l,r,g,b,u)

  #define APL_POLYLINE_MAJUNOR(p)                AgentPlanLogger::apl->writePolyLine(p)
  #define APL_POLYLINE2_MAJUNOR(p,l)             AgentPlanLogger::apl->writePolyLine(p,l)
  #define APL_POLYLINE3_MAJUNOR(p,l,r,g,b)       AgentPlanLogger::apl->writePolyLine(p,l,r,g,b)
  #define APL_POLYLINE4_MAJUNOR(p,l,r,g,b,u)     AgentPlanLogger::apl->writePolyLine(p,l,r,g,b,u)

  #define APL_ELLIPSE_MAJUNOR(p,w,h)             AgentPlanLogger::apl->writeEllipse(p,w,h)
  #define APL_ELLIPSE2_MAJUNOR(p,w,h,l)          AgentPlanLogger::apl->writeEllipse(p,w,h,l)
  #define APL_ELLIPSE3_MAJUNOR(p,w,h,l,r,g,b)    AgentPlanLogger::apl->writeEllipse(p,w,h,l,r,g,b)
  #define APL_ELLIPSE4_MAJUNOR(p,w,h,l,r,g,b,u)  AgentPlanLogger::apl->writeEllipse(p,w,h,l,r,g,b,u)

  #define APL_ALLPLAYERS_MAJUNOR()               AgentPlanLogger::apl->writeAllPlayerPositions()
  #define APL_ALLPLAYERS2_MAJUNOR(l)             AgentPlanLogger::apl->writeAllPlayerPositions(l)
  #define APL_ALLPLAYERS3_MAJUNOR(l,c)           AgentPlanLogger::apl->writeAllPlayerPositions(l,c)

  #define APL_BALL_MAJUNOR()                     AgentPlanLogger::apl->writeBall()
  #define APL_BALL2_MAJUNOR(l)                   AgentPlanLogger::apl->writeBall(l)
  #define APL_BALL3_MAJUNOR(l,c)                 AgentPlanLogger::apl->writeBall(l,c)
  
  #define APL_INTERCEPTIONPOINT_MAJUNOR()        AgentPlanLogger::apl->writeInterceptionPoint()
  #define APL_INTERCEPTIONPOINT2_MAJUNOR(l)      AgentPlanLogger::apl->writeInterceptionPoint(l)
  #define APL_INTERCEPTIONPOINT3_MAJUNOR(l,c)    AgentPlanLogger::apl->writeInterceptionPoint(l,c)
 
#else // !AGENT_PLAN_LOG_MAJUNOR
  #define APL_POINT_MAJUNOR(p)                   ;
  #define APL_POINT2_MAJUNOR(p,l)                ;
  #define APL_POINT3_MAJUNOR(p,l,r,g,b)          ;
  #define APL_POINT4_MAJUNOR(p,l,r,g,b,u)        ;

  #define APL_LINE_MAJUNOR(p1,p2)                ;
  #define APL_LINE2_MAJUNOR(p1,p2,l)             ;
  #define APL_LINE3_MAJUNOR(p1,p2,l,r,g,b)       ;
  #define APL_LINE4_MAJUNOR(p1,p2,l,r,g,b,u)     ;

  #define APL_POLYLINE_MAJUNOR(p)                ;
  #define APL_POLYLINE2_MAJUNOR(p,l)             ;
  #define APL_POLYLINE3_MAJUNOR(p,l,r,g,b)       ;
  #define APL_POLYLINE4_MAJUNOR(p,l,r,g,b,u)     ;

  #define APL_ELLIPSE_MAJUNOR(p,w,h)             ;
  #define APL_ELLIPSE2_MAJUNOR(p,w,h,l)          ;
  #define APL_ELLIPSE3_MAJUNOR(p,w,h,l,r,g,b)    ;
  #define APL_ELLIPSE4_MAJUNOR(p,w,h,l,r,g,b,u)  ;

  #define APL_ALLPLAYERS_MAJUNOR()               ;
  #define APL_ALLPLAYERS2_MAJUNOR(l)             ;
  #define APL_ALLPLAYERS3_MAJUNOR(l,c)           ;

  #define APL_BALL_MAJUNOR()                     ;
  #define APL_BALL2_MAJUNOR(l)                   ;
  #define APL_BALL3_MAJUNOR(l,c)                 ;

  #define APL_INTERCEPTIONPOINT_MAJUNOR()        ;
  #define APL_INTERCEPTIONPOINT2_MAJUNOR(l)      ;
  #define APL_INTERCEPTIONPOINT3_MAJUNOR(l,c)    ;
 
#endif // AGENT_PLAN_LOG_MAJUNOR

#if defined (AGENT_PLAN_LOG_MOSH)
  #define APL_POINT_MOSH(p)                   AgentPlanLogger::apl->writePoint(p)
  #define APL_POINT2_MOSH(p,l)                AgentPlanLogger::apl->writePoint(p,l)
  #define APL_POINT3_MOSH(p,l,r,g,b)          AgentPlanLogger::apl->writePoint(p,l,r,g,b)
  #define APL_POINT4_MOSH(p,l,r,g,b,u)        AgentPlanLogger::apl->writePoint(p,l,r,g,b,u)

  #define APL_LINE_MOSH(p1,p2)                AgentPlanLogger::apl->writeLine(p1,p2)
  #define APL_LINE2_MOSH(p1,p2,l)             AgentPlanLogger::apl->writeLine(p1,p2,l)
  #define APL_LINE3_MOSH(p1,p2,l,r,g,b)       AgentPlanLogger::apl->writeLine(p1,p2,l,r,g,b)
  #define APL_LINE4_MOSH(p1,p2,l,r,g,b,u)     AgentPlanLogger::apl->writeLine(p1,p2,l,r,g,b,u)

  #define APL_POLYLINE_MOSH(p)                AgentPlanLogger::apl->writePolyLine(p)
  #define APL_POLYLINE2_MOSH(p,l)             AgentPlanLogger::apl->writePolyLine(p,l)
  #define APL_POLYLINE3_MOSH(p,l,r,g,b)       AgentPlanLogger::apl->writePolyLine(p,l,r,g,b)
  #define APL_POLYLINE4_MOSH(p,l,r,g,b,u)     AgentPlanLogger::apl->writePolyLine(p,l,r,g,b,u)

  #define APL_ELLIPSE_MOSH(p,w,h)             AgentPlanLogger::apl->writeEllipse(p,w,h)
  #define APL_ELLIPSE2_MOSH(p,w,h,l)          AgentPlanLogger::apl->writeEllipse(p,w,h,l)
  #define APL_ELLIPSE3_MOSH(p,w,h,l,r,g,b)    AgentPlanLogger::apl->writeEllipse(p,w,h,l,r,g,b)
  #define APL_ELLIPSE4_MOSH(p,w,h,l,r,g,b,u)  AgentPlanLogger::apl->writeEllipse(p,w,h,l,r,g,b,u)

  #define APL_ALLPLAYERS_MOSH()               AgentPlanLogger::apl->writeAllPlayerPositions()
  #define APL_ALLPLAYERS2_MOSH(l)             AgentPlanLogger::apl->writeAllPlayerPositions(l)
  #define APL_ALLPLAYERS3_MOSH(l,c)           AgentPlanLogger::apl->writeAllPlayerPositions(l,c)

  #define APL_BALL_MOSH()                     AgentPlanLogger::apl->writeBall()
  #define APL_BALL2_MOSH(l)                   AgentPlanLogger::apl->writeBall(l)
  #define APL_BALL3_MOSH(l,c)                 AgentPlanLogger::apl->writeBall(l,c)
  
  #define APL_INTERCEPTIONPOINT_MOSH()        AgentPlanLogger::apl->writeInterceptionPoint()
  #define APL_INTERCEPTIONPOINT2_MOSH(l)      AgentPlanLogger::apl->writeInterceptionPoint(l)
  #define APL_INTERCEPTIONPOINT3_MOSH(l,c)    AgentPlanLogger::apl->writeInterceptionPoint(l,c)
 
#else // !AGENT_PLAN_LOG_MOSH
  #define APL_POINT_MOSH(p)                   ;
  #define APL_POINT2_MOSH(p,l)                ;
  #define APL_POINT3_MOSH(p,l,r,g,b)          ;
  #define APL_POINT4_MOSH(p,l,r,g,b,u)        ;

  #define APL_LINE_MOSH(p1,p2)                ;
  #define APL_LINE2_MOSH(p1,p2,l)             ;
  #define APL_LINE3_MOSH(p1,p2,l,r,g,b)       ;
  #define APL_LINE4_MOSH(p1,p2,l,r,g,b,u)     ;

  #define APL_POLYLINE_MOSH(p)                ;
  #define APL_POLYLINE2_MOSH(p,l)             ;
  #define APL_POLYLINE3_MOSH(p,l,r,g,b)       ;
  #define APL_POLYLINE4_MOSH(p,l,r,g,b,u)     ;

  #define APL_ELLIPSE_MOSH(p,w,h)             ;
  #define APL_ELLIPSE2_MOSH(p,w,h,l)          ;
  #define APL_ELLIPSE3_MOSH(p,w,h,l,r,g,b)    ;
  #define APL_ELLIPSE4_MOSH(p,w,h,l,r,g,b,u)  ;

  #define APL_ALLPLAYERS_MOSH()               ;
  #define APL_ALLPLAYERS2_MOSH(l)             ;
  #define APL_ALLPLAYERS3_MOSH(l,c)           ;

  #define APL_BALL_MOSH()                     ;
  #define APL_BALL2_MOSH(l)                   ;
  #define APL_BALL3_MOSH(l,c)                 ;

  #define APL_INTERCEPTIONPOINT_MOSH()        ;
  #define APL_INTERCEPTIONPOINT2_MOSH(l)      ;
  #define APL_INTERCEPTIONPOINT3_MOSH(l,c)    ;
 
#endif // AGENT_PLAN_LOG_MOSH


#if defined (AGENT_PLAN_LOG_HARLEKIN)
  #define APL_POINT_HARLEKIN(p)                   AgentPlanLogger::apl->writePoint(p)
  #define APL_POINT2_HARLEKIN(p,l)                AgentPlanLogger::apl->writePoint(p,l)
  #define APL_POINT3_HARLEKIN(p,l,r,g,b)          AgentPlanLogger::apl->writePoint(p,l,r,g,b)
  #define APL_POINT4_HARLEKIN(p,l,r,g,b,u)        AgentPlanLogger::apl->writePoint(p,l,r,g,b,u)

  #define APL_LINE_HARLEKIN(p1,p2)                AgentPlanLogger::apl->writeLine(p1,p2)
  #define APL_LINE2_HARLEKIN(p1,p2,l)             AgentPlanLogger::apl->writeLine(p1,p2,l)
  #define APL_LINE3_HARLEKIN(p1,p2,l,r,g,b)       AgentPlanLogger::apl->writeLine(p1,p2,l,r,g,b)
  #define APL_LINE4_HARLEKIN(p1,p2,l,r,g,b,u)     AgentPlanLogger::apl->writeLine(p1,p2,l,r,g,b,u)

  #define APL_POLYLINE_HARLEKIN(p)                AgentPlanLogger::apl->writePolyLine(p)
  #define APL_POLYLINE2_HARLEKIN(p,l)             AgentPlanLogger::apl->writePolyLine(p,l)
  #define APL_POLYLINE3_HARLEKIN(p,l,r,g,b)       AgentPlanLogger::apl->writePolyLine(p,l,r,g,b)
  #define APL_POLYLINE4_HARLEKIN(p,l,r,g,b,u)     AgentPlanLogger::apl->writePolyLine(p,l,r,g,b,u)

  #define APL_ELLIPSE_HARLEKIN(p,w,h)             AgentPlanLogger::apl->writeEllipse(p,w,h)
  #define APL_ELLIPSE2_HARLEKIN(p,w,h,l)          AgentPlanLogger::apl->writeEllipse(p,w,h,l)
  #define APL_ELLIPSE3_HARLEKIN(p,w,h,l,r,g,b)    AgentPlanLogger::apl->writeEllipse(p,w,h,l,r,g,b)
  #define APL_ELLIPSE4_HARLEKIN(p,w,h,l,r,g,b,u)  AgentPlanLogger::apl->writeEllipse(p,w,h,l,r,g,b,u)

  #define APL_ALLPLAYERS_HARLEKIN()               AgentPlanLogger::apl->writeAllPlayerPositions()
  #define APL_ALLPLAYERS2_HARLEKIN(l)             AgentPlanLogger::apl->writeAllPlayerPositions(l)
  #define APL_ALLPLAYERS3_HARLEKIN(l,c)           AgentPlanLogger::apl->writeAllPlayerPositions(l,c)

  #define APL_BALL_HARLEKIN()                     AgentPlanLogger::apl->writeBall()
  #define APL_BALL2_HARLEKIN(l)                   AgentPlanLogger::apl->writeBall(l)
  #define APL_BALL3_HARLEKIN(l,c)                 AgentPlanLogger::apl->writeBall(l,c)
  
  #define APL_INTERCEPTIONPOINT_HARLEKIN()        AgentPlanLogger::apl->writeInterceptionPoint()
  #define APL_INTERCEPTIONPOINT2_HARLEKIN(l)      AgentPlanLogger::apl->writeInterceptionPoint(l)
  #define APL_INTERCEPTIONPOINT3_HARLEKIN(l,c)    AgentPlanLogger::apl->writeInterceptionPoint(l,c)
 
#else // !AGENT_PLAN_LOG_HARLEKIN
  #define APL_POINT_HARLEKIN(p)                   ;
  #define APL_POINT2_HARLEKIN(p,l)                ;
  #define APL_POINT3_HARLEKIN(p,l,r,g,b)          ;
  #define APL_POINT4_HARLEKIN(p,l,r,g,b,u)        ;

  #define APL_LINE_HARLEKIN(p1,p2)                ;
  #define APL_LINE2_HARLEKIN(p1,p2,l)             ;
  #define APL_LINE3_HARLEKIN(p1,p2,l,r,g,b)       ;
  #define APL_LINE4_HARLEKIN(p1,p2,l,r,g,b,u)     ;

  #define APL_POLYLINE_HARLEKIN(p)                ;
  #define APL_POLYLINE2_HARLEKIN(p,l)             ;
  #define APL_POLYLINE3_HARLEKIN(p,l,r,g,b)       ;
  #define APL_POLYLINE4_HARLEKIN(p,l,r,g,b,u)     ;

  #define APL_ELLIPSE_HARLEKIN(p,w,h)             ;
  #define APL_ELLIPSE2_HARLEKIN(p,w,h,l)          ;
  #define APL_ELLIPSE3_HARLEKIN(p,w,h,l,r,g,b)    ;
  #define APL_ELLIPSE4_HARLEKIN(p,w,h,l,r,g,b,u)  ;

  #define APL_ALLPLAYERS_HARLEKIN()               ;
  #define APL_ALLPLAYERS2_HARLEKIN(l)             ;
  #define APL_ALLPLAYERS3_HARLEKIN(l,c)           ;

  #define APL_BALL_HARLEKIN()                     ;
  #define APL_BALL2_HARLEKIN(l)                   ;
  #define APL_BALL3_HARLEKIN(l,c)                 ;

  #define APL_INTERCEPTIONPOINT_HARLEKIN()        ;
  #define APL_INTERCEPTIONPOINT2_HARLEKIN(l)      ;
  #define APL_INTERCEPTIONPOINT3_HARLEKIN(l,c)    ;
 
#endif // AGENT_PLAN_LOG_HARLEKIN

#if defined (AGENT_PLAN_LOG_CNIEHAUS)
  #define APL_POINT_CNIEHAUS(p)                   AgentPlanLogger::apl->writePoint(p)
  #define APL_POINT2_CNIEHAUS(p,l)                AgentPlanLogger::apl->writePoint(p,l)
  #define APL_POINT3_CNIEHAUS(p,l,r,g,b)          AgentPlanLogger::apl->writePoint(p,l,r,g,b)
  #define APL_POINT4_CNIEHAUS(p,l,r,g,b,u)        AgentPlanLogger::apl->writePoint(p,l,r,g,b,u)

  #define APL_LINE_CNIEHAUS(p1,p2)                AgentPlanLogger::apl->writeLine(p1,p2)
  #define APL_LINE2_CNIEHAUS(p1,p2,l)             AgentPlanLogger::apl->writeLine(p1,p2,l)
  #define APL_LINE3_CNIEHAUS(p1,p2,l,r,g,b)       AgentPlanLogger::apl->writeLine(p1,p2,l,r,g,b)
  #define APL_LINE4_CNIEHAUS(p1,p2,l,r,g,b,u)     AgentPlanLogger::apl->writeLine(p1,p2,l,r,g,b,u)

  #define APL_POLYLINE_CNIEHAUS(p)                AgentPlanLogger::apl->writePolyLine(p)
  #define APL_POLYLINE2_CNIEHAUS(p,l)             AgentPlanLogger::apl->writePolyLine(p,l)
  #define APL_POLYLINE3_CNIEHAUS(p,l,r,g,b)       AgentPlanLogger::apl->writePolyLine(p,l,r,g,b)
  #define APL_POLYLINE4_CNIEHAUS(p,l,r,g,b,u)     AgentPlanLogger::apl->writePolyLine(p,l,r,g,b,u)

  #define APL_ELLIPSE_CNIEHAUS(p,w,h)             AgentPlanLogger::apl->writeEllipse(p,w,h)
  #define APL_ELLIPSE2_CNIEHAUS(p,w,h,l)          AgentPlanLogger::apl->writeEllipse(p,w,h,l)
  #define APL_ELLIPSE3_CNIEHAUS(p,w,h,l,r,g,b)    AgentPlanLogger::apl->writeEllipse(p,w,h,l,r,g,b)
  #define APL_ELLIPSE4_CNIEHAUS(p,w,h,l,r,g,b,u)  AgentPlanLogger::apl->writeEllipse(p,w,h,l,r,g,b,u)

  #define APL_ALLPLAYERS_CNIEHAUS()               AgentPlanLogger::apl->writeAllPlayerPositions()
  #define APL_ALLPLAYERS2_CNIEHAUS(l)             AgentPlanLogger::apl->writeAllPlayerPositions(l)
  #define APL_ALLPLAYERS3_CNIEHAUS(l,c)           AgentPlanLogger::apl->writeAllPlayerPositions(l,c)

  #define APL_BALL_CNIEHAUS()                     AgentPlanLogger::apl->writeBall()
  #define APL_BALL2_CNIEHAUS(l)                   AgentPlanLogger::apl->writeBall(l)
  #define APL_BALL3_CNIEHAUS(l,c)                 AgentPlanLogger::apl->writeBall(l,c)
  
  #define APL_INTERCEPTIONPOINT_CNIEHAUS()        AgentPlanLogger::apl->writeInterceptionPoint()
  #define APL_INTERCEPTIONPOINT2_CNIEHAUS(l)      AgentPlanLogger::apl->writeInterceptionPoint(l)
  #define APL_INTERCEPTIONPOINT3_CNIEHAUS(l,c)    AgentPlanLogger::apl->writeInterceptionPoint(l,c)
 
#else // !AGENT_PLAN_LOG_CNIEHAUS
  #define APL_POINT_CNIEHAUS(p)                   ;
  #define APL_POINT2_CNIEHAUS(p,l)                ;
  #define APL_POINT3_CNIEHAUS(p,l,r,g,b)          ;
  #define APL_POINT4_CNIEHAUS(p,l,r,g,b,u)        ;

  #define APL_LINE_CNIEHAUS(p1,p2)                ;
  #define APL_LINE2_CNIEHAUS(p1,p2,l)             ;
  #define APL_LINE3_CNIEHAUS(p1,p2,l,r,g,b)       ;
  #define APL_LINE4_CNIEHAUS(p1,p2,l,r,g,b,u)     ;

  #define APL_POLYLINE_CNIEHAUS(p)                ;
  #define APL_POLYLINE2_CNIEHAUS(p,l)             ;
  #define APL_POLYLINE3_CNIEHAUS(p,l,r,g,b)       ;
  #define APL_POLYLINE4_CNIEHAUS(p,l,r,g,b,u)     ;

  #define APL_ELLIPSE_CNIEHAUS(p,w,h)             ;
  #define APL_ELLIPSE2_CNIEHAUS(p,w,h,l)          ;
  #define APL_ELLIPSE3_CNIEHAUS(p,w,h,l,r,g,b)    ;
  #define APL_ELLIPSE4_CNIEHAUS(p,w,h,l,r,g,b,u)  ;

  #define APL_ALLPLAYERS_CNIEHAUS()               ;
  #define APL_ALLPLAYERS2_CNIEHAUS(l)             ;
  #define APL_ALLPLAYERS3_CNIEHAUS(l,c)           ;

  #define APL_BALL_CNIEHAUS()                     ;
  #define APL_BALL2_CNIEHAUS(l)                   ;
  #define APL_BALL3_CNIEHAUS(l,c)                 ;

  #define APL_INTERCEPTIONPOINT_CNIEHAUS()        ;
  #define APL_INTERCEPTIONPOINT2_CNIEHAUS(l)      ;
  #define APL_INTERCEPTIONPOINT3_CNIEHAUS(l,c)    ;
 
#endif // AGENT_PLAN_LOG_CNIEHAUS


#if defined (AGENT_PLAN_LOG_KHUEBNER)
  #define APL_POINT_KHUEBNER(p)                   AgentPlanLogger::apl->writePoint(p)
  #define APL_POINT2_KHUEBNER(p,l)                AgentPlanLogger::apl->writePoint(p,l)
  #define APL_POINT3_KHUEBNER(p,l,r,g,b)          AgentPlanLogger::apl->writePoint(p,l,r,g,b)
  #define APL_POINT4_KHUEBNER(p,l,r,g,b,u)        AgentPlanLogger::apl->writePoint(p,l,r,g,b,u)

  #define APL_LINE_KHUEBNER(p1,p2)                AgentPlanLogger::apl->writeLine(p1,p2)
  #define APL_LINE2_KHUEBNER(p1,p2,l)             AgentPlanLogger::apl->writeLine(p1,p2,l)
  #define APL_LINE3_KHUEBNER(p1,p2,l,r,g,b)       AgentPlanLogger::apl->writeLine(p1,p2,l,r,g,b)
  #define APL_LINE4_KHUEBNER(p1,p2,l,r,g,b,u)     AgentPlanLogger::apl->writeLine(p1,p2,l,r,g,b,u)

  #define APL_POLYLINE_KHUEBNER(p)                AgentPlanLogger::apl->writePolyLine(p)
  #define APL_POLYLINE2_KHUEBNER(p,l)             AgentPlanLogger::apl->writePolyLine(p,l)
  #define APL_POLYLINE3_KHUEBNER(p,l,r,g,b)       AgentPlanLogger::apl->writePolyLine(p,l,r,g,b)
  #define APL_POLYLINE4_KHUEBNER(p,l,r,g,b,u)     AgentPlanLogger::apl->writePolyLine(p,l,r,g,b,u)

  #define APL_ELLIPSE_KHUEBNER(p,w,h)             AgentPlanLogger::apl->writeEllipse(p,w,h)
  #define APL_ELLIPSE2_KHUEBNER(p,w,h,l)          AgentPlanLogger::apl->writeEllipse(p,w,h,l)
  #define APL_ELLIPSE3_KHUEBNER(p,w,h,l,r,g,b)    AgentPlanLogger::apl->writeEllipse(p,w,h,l,r,g,b)
  #define APL_ELLIPSE4_KHUEBNER(p,w,h,l,r,g,b,u)  AgentPlanLogger::apl->writeEllipse(p,w,h,l,r,g,b,u)

  #define APL_ALLPLAYERS_KHUEBNER()               AgentPlanLogger::apl->writeAllPlayerPositions()
  #define APL_ALLPLAYERS2_KHUEBNER(l)             AgentPlanLogger::apl->writeAllPlayerPositions(l)
  #define APL_ALLPLAYERS3_KHUEBNER(l,c)           AgentPlanLogger::apl->writeAllPlayerPositions(l,c)

  #define APL_BALL_KHUEBNER()                     AgentPlanLogger::apl->writeBall()
  #define APL_BALL2_KHUEBNER(l)                   AgentPlanLogger::apl->writeBall(l)
  #define APL_BALL3_KHUEBNER(l,c)                 AgentPlanLogger::apl->writeBall(l,c)
  
  #define APL_INTERCEPTIONPOINT_KHUEBNER()        AgentPlanLogger::apl->writeInterceptionPoint()
  #define APL_INTERCEPTIONPOINT2_KHUEBNER(l)      AgentPlanLogger::apl->writeInterceptionPoint(l)
  #define APL_INTERCEPTIONPOINT3_KHUEBNER(l,c)    AgentPlanLogger::apl->writeInterceptionPoint(l,c)
 
#else // !AGENT_PLAN_LOG_KHUEBNER
  #define APL_POINT_KHUEBNER(p)                   ;
  #define APL_POINT2_KHUEBNER(p,l)                ;
  #define APL_POINT3_KHUEBNER(p,l,r,g,b)          ;
  #define APL_POINT4_KHUEBNER(p,l,r,g,b,u)        ;

  #define APL_LINE_KHUEBNER(p1,p2)                ;
  #define APL_LINE2_KHUEBNER(p1,p2,l)             ;
  #define APL_LINE3_KHUEBNER(p1,p2,l,r,g,b)       ;
  #define APL_LINE4_KHUEBNER(p1,p2,l,r,g,b,u)     ;

  #define APL_POLYLINE_KHUEBNER(p)                ;
  #define APL_POLYLINE2_KHUEBNER(p,l)             ;
  #define APL_POLYLINE3_KHUEBNER(p,l,r,g,b)       ;
  #define APL_POLYLINE4_KHUEBNER(p,l,r,g,b,u)     ;

  #define APL_ELLIPSE_KHUEBNER(p,w,h)             ;
  #define APL_ELLIPSE2_KHUEBNER(p,w,h,l)          ;
  #define APL_ELLIPSE3_KHUEBNER(p,w,h,l,r,g,b)    ;
  #define APL_ELLIPSE4_KHUEBNER(p,w,h,l,r,g,b,u)  ;

  #define APL_ALLPLAYERS_KHUEBNER()               ;
  #define APL_ALLPLAYERS2_KHUEBNER(l)             ;
  #define APL_ALLPLAYERS3_KHUEBNER(l,c)           ;

  #define APL_BALL_KHUEBNER()                     ;
  #define APL_BALL2_KHUEBNER(l)                   ;
  #define APL_BALL3_KHUEBNER(l,c)                 ;

  #define APL_INTERCEPTIONPOINT_KHUEBNER()        ;
  #define APL_INTERCEPTIONPOINT2_KHUEBNER(l)      ;
  #define APL_INTERCEPTIONPOINT3_KHUEBNER(l,c)    ;
 
#endif // AGENT_PLAN_LOG_KHUEBNER


#ifdef DEBUG_ON
  #define DUMPVAR(a)                     cout << #a << "=" << a << endl
  #define DEBUG1(a)                      cout << a << endl
  #define DEBUG2(a,b)                    cout << a << b << endl
  #define DEBUG3(a,b,c)                  cout << a << b << c << endl
  #define DEBUG4(a,b,c,d)                cout << a << b << c << d << endl
  #define DEBUG5(a,b,c,d,e)              cout << a << b << c << d << e << endl
  #define DEBUG6(a,b,c,d,e,f)            cout << a << b << c << d << e << f \
                                              << endl
  #define DEBUG7(a,b,c,d,e,f,g)          cout << a << b << c << d << e << f \
                                              << g << endl
  #define DEBUG8(a,b,c,d,e,f,g,h)        cout << a << b << c << d << e << f \
                                              << g << h << endl
  #define DEBUG9(a,b,c,d,e,f,g,h,i)      cout << a << b << c << d << e << f \
                                              << g << h << i << endl
  #define DUMPVAR_CERR(a)                cerr << #a << "=" << a << endl
  #define DEBUG1_CERR(a)                 cerr << a << endl
  #define DEBUG2_CERR(a,b)               cerr << a << b << endl
  #define DEBUG3_CERR(a,b,c)             cerr << a << b << c << endl
  #define DEBUG4_CERR(a,b,c,d)           cerr << a << b << c << d << endl
  #define DEBUG5_CERR(a,b,c,d,e)         cerr << a << b << c << d << e << endl
  #define DEBUG6_CERR(a,b,c,d,e,f)       cerr << a << b << c << d << e << f \
                                              << endl
  #define DEBUG7_CERR(a,b,c,d,e,f,g)     cerr << a << b << c << d << e << f \
                                              << g << endl
  #define DEBUG8_CERR(a,b,c,d,e,f,g,h)   cerr << a << b << c << d << e << f \
                                              << g << h << endl
  #define DEBUG9_CERR(a,b,c,d,e,f,g,h,i) cerr << a << b << c << d << e << f \
                                              << g << h << i << endl

#else // !DEBUG_ON
  #define DUMPVAR(a)                     ;
  #define DEBUG1(a)                      ;
  #define DEBUG2(a,b)                    ;
  #define DEBUG3(a,b,c)                  ;
  #define DEBUG4(a,b,c,d)                ;
  #define DEBUG5(a,b,c,d,e)              ;
  #define DEBUG6(a,b,c,d,e,f)            ;
  #define DEBUG7(a,b,c,d,e,f,g)          ;
  #define DEBUG8(a,b,c,d,e,f,g,h)        ;
  #define DEBUG9(a,b,c,d,e,f,g,h,i)      ;
  #define DUMPVAR_CERR(a)                ;
  #define DEBUG1_CERR(a)                 ;
  #define DEBUG2_CERR(a,b)               ;
  #define DEBUG3_CERR(a,b,c)             ;
  #define DEBUG4_CERR(a,b,c,d)           ;
  #define DEBUG5_CERR(a,b,c,d,e)         ;
  #define DEBUG6_CERR(a,b,c,d,e,f)       ;
  #define DEBUG7_CERR(a,b,c,d,e,f,g)     ;
  #define DEBUG8_CERR(a,b,c,d,e,f,g,h)   ;
  #define DEBUG9_CERR(a,b,c,d,e,f,g,h,i) ;
#endif // DEBUG_ON






  #if defined (DEBUG_FOR_TEKGEIST)
    #define DUMPVAR_TEKGEIST(a)                     cout << #a << "=" << a << endl
    #define DEBUG1_TEKGEIST(a)                      cout << a << endl
    #define DEBUG2_TEKGEIST(a,b)                    cout << a << b << endl
    #define DEBUG3_TEKGEIST(a,b,c)                  cout << a << b << c << endl
    #define DEBUG4_TEKGEIST(a,b,c,d)                cout << a << b << c << d << endl
    #define DEBUG5_TEKGEIST(a,b,c,d,e)              cout << a << b << c << d << e << endl
    #define DEBUG6_TEKGEIST(a,b,c,d,e,f)            cout << a << b << c << d << e << f \
                                                        << endl
    #define DEBUG7_TEKGEIST(a,b,c,d,e,f,g)          cout << a << b << c << d << e << f \
                                                        << g << endl
    #define DEBUG8_TEKGEIST(a,b,c,d,e,f,g,h)        cout << a << b << c << d << e << f \
                                                        << g << h << endl
    #define DEBUG9_TEKGEIST(a,b,c,d,e,f,g,h,i)      cout << a << b << c << d << e << f \
                                                        << g << h << i << endl
    #define DUMPVAR_CERR_TEKGEIST(a)                cerr << #a << "=" << a << endl
    #define DEBUG1_CERR_TEKGEIST(a)                 cerr << a << endl
    #define DEBUG2_CERR_TEKGEIST(a,b)               cerr << a << b << endl
    #define DEBUG3_CERR_TEKGEIST(a,b,c)             cerr << a << b << c << endl
    #define DEBUG4_CERR_TEKGEIST(a,b,c,d)           cerr << a << b << c << d << endl
    #define DEBUG5_CERR_TEKGEIST(a,b,c,d,e)         cerr << a << b << c << d << e << endl
    #define DEBUG6_CERR_TEKGEIST(a,b,c,d,e,f)       cerr << a << b << c << d << e << f \
                                                        << endl
    #define DEBUG7_CERR_TEKGEIST(a,b,c,d,e,f,g)     cerr << a << b << c << d << e << f \
                                                        << g << endl
    #define DEBUG8_CERR_TEKGEIST(a,b,c,d,e,f,g,h)   cerr << a << b << c << d << e << f \
                                                        << g << h << endl
    #define DEBUG9_CERR_TEKGEIST(a,b,c,d,e,f,g,h,i) cerr << a << b << c << d << e << f \
                                                        << g << h << i << endl
  #else // !DEBUG_FOR_TEKGEIST
    #define DUMPVAR_TEKGEIST(a)                     ;
    #define DEBUG1_TEKGEIST(a)                      ;
    #define DEBUG2_TEKGEIST(a,b)                    ;
    #define DEBUG3_TEKGEIST(a,b,c)                  ;
    #define DEBUG4_TEKGEIST(a,b,c,d)                ;
    #define DEBUG5_TEKGEIST(a,b,c,d,e)              ;
    #define DEBUG6_TEKGEIST(a,b,c,d,e,f)            ;
    #define DEBUG7_TEKGEIST(a,b,c,d,e,f,g)          ;
    #define DEBUG8_TEKGEIST(a,b,c,d,e,f,g,h)        ;
    #define DEBUG9_TEKGEIST(a,b,c,d,e,f,g,h,i)      ;
    #define DUMPVAR_CERR_TEKGEIST(a)                ;
    #define DEBUG1_CERR_TEKGEIST(a)                 ;
    #define DEBUG2_CERR_TEKGEIST(a,b)               ;
    #define DEBUG3_CERR_TEKGEIST(a,b,c)             ;
    #define DEBUG4_CERR_TEKGEIST(a,b,c,d)           ;
    #define DEBUG5_CERR_TEKGEIST(a,b,c,d,e)         ;
    #define DEBUG6_CERR_TEKGEIST(a,b,c,d,e,f)       ;
    #define DEBUG7_CERR_TEKGEIST(a,b,c,d,e,f,g)     ;
    #define DEBUG8_CERR_TEKGEIST(a,b,c,d,e,f,g,h)   ;
    #define DEBUG9_CERR_TEKGEIST(a,b,c,d,e,f,g,h,i) ;
  #endif //DEBUG_FOR_TEKGEIST

  #if defined (DEBUG_FOR_MAJUNOR)
    #define DUMPVAR_MAJUNOR(a)                     cout << #a << "=" << a << endl
    #define DEBUG1_MAJUNOR(a)                      cout << a << endl
    #define DEBUG2_MAJUNOR(a,b)                    cout << a << b << endl
    #define DEBUG3_MAJUNOR(a,b,c)                  cout << a << b << c << endl
    #define DEBUG4_MAJUNOR(a,b,c,d)                cout << a << b << c << d << endl
    #define DEBUG5_MAJUNOR(a,b,c,d,e)              cout << a << b << c << d << e << endl
    #define DEBUG6_MAJUNOR(a,b,c,d,e,f)            cout << a << b << c << d << e << f \
                                                        << endl
    #define DEBUG7_MAJUNOR(a,b,c,d,e,f,g)          cout << a << b << c << d << e << f \
                                                        << g << endl
    #define DEBUG8_MAJUNOR(a,b,c,d,e,f,g,h)        cout << a << b << c << d << e << f \
                                                        << g << h << endl
    #define DEBUG9_MAJUNOR(a,b,c,d,e,f,g,h,i)      cout << a << b << c << d << e << f \
                                                        << g << h << i << endl
    #define DUMPVAR_CERR_MAJUNOR(a)                cerr << #a << "=" << a << endl
    #define DEBUG1_CERR_MAJUNOR(a)                 cerr << a << endl
    #define DEBUG2_CERR_MAJUNOR(a,b)               cerr << a << b << endl
    #define DEBUG3_CERR_MAJUNOR(a,b,c)             cerr << a << b << c << endl
    #define DEBUG4_CERR_MAJUNOR(a,b,c,d)           cerr << a << b << c << d << endl
    #define DEBUG5_CERR_MAJUNOR(a,b,c,d,e)         cerr << a << b << c << d << e << endl
    #define DEBUG6_CERR_MAJUNOR(a,b,c,d,e,f)       cerr << a << b << c << d << e << f \
                                                        << endl
    #define DEBUG7_CERR_MAJUNOR(a,b,c,d,e,f,g)     cerr << a << b << c << d << e << f \
                                                        << g << endl
    #define DEBUG8_CERR_MAJUNOR(a,b,c,d,e,f,g,h)   cerr << a << b << c << d << e << f \
                                                        << g << h << endl
    #define DEBUG9_CERR_MAJUNOR(a,b,c,d,e,f,g,h,i) cerr << a << b << c << d << e << f \
                                                        << g << h << i << endl
  #else // !DEBUG_FOR_MAJUNOR
    #define DUMPVAR_MAJUNOR(a)                     ;
    #define DEBUG1_MAJUNOR(a)                      ;
    #define DEBUG2_MAJUNOR(a,b)                    ;
    #define DEBUG3_MAJUNOR(a,b,c)                  ;
    #define DEBUG4_MAJUNOR(a,b,c,d)                ;
    #define DEBUG5_MAJUNOR(a,b,c,d,e)              ;
    #define DEBUG6_MAJUNOR(a,b,c,d,e,f)            ;
    #define DEBUG7_MAJUNOR(a,b,c,d,e,f,g)          ;
    #define DEBUG8_MAJUNOR(a,b,c,d,e,f,g,h)        ;
    #define DEBUG9_MAJUNOR(a,b,c,d,e,f,g,h,i)      ;
    #define DUMPVAR_CERR_MAJUNOR(a)                ;
    #define DEBUG1_CERR_MAJUNOR(a)                 ;
    #define DEBUG2_CERR_MAJUNOR(a,b)               ;
    #define DEBUG3_CERR_MAJUNOR(a,b,c)             ;
    #define DEBUG4_CERR_MAJUNOR(a,b,c,d)           ;
    #define DEBUG5_CERR_MAJUNOR(a,b,c,d,e)         ;
    #define DEBUG6_CERR_MAJUNOR(a,b,c,d,e,f)       ;
    #define DEBUG7_CERR_MAJUNOR(a,b,c,d,e,f,g)     ;
    #define DEBUG8_CERR_MAJUNOR(a,b,c,d,e,f,g,h)   ;
    #define DEBUG9_CERR_MAJUNOR(a,b,c,d,e,f,g,h,i) ;
  #endif //DEBUG_FOR_MAJUNOR

#if defined (DEBUG_FOR_CNIEHAUS)
    #define DUMPVAR_CNIEHAUS(a)                     cout << #a << "=" << a << endl
    #define DEBUG1_CNIEHAUS(a)                      cout << a << endl
    #define DEBUG2_CNIEHAUS(a,b)                    cout << a << b << endl
    #define DEBUG3_CNIEHAUS(a,b,c)                  cout << a << b << c << endl
    #define DEBUG4_CNIEHAUS(a,b,c,d)                cout << a << b << c << d << endl
    #define DEBUG5_CNIEHAUS(a,b,c,d,e)              cout << a << b << c << d << e << endl
    #define DEBUG6_CNIEHAUS(a,b,c,d,e,f)            cout << a << b << c << d << e << f \
                                                        << endl
    #define DEBUG7_CNIEHAUS(a,b,c,d,e,f,g)          cout << a << b << c << d << e << f \
                                                        << g << endl
    #define DEBUG8_CNIEHAUS(a,b,c,d,e,f,g,h)        cout << a << b << c << d << e << f \
                                                        << g << h << endl
    #define DEBUG9_CNIEHAUS(a,b,c,d,e,f,g,h,i)      cout << a << b << c << d << e << f \
                                                        << g << h << i << endl
    #define DUMPVAR_CERR_CNIEHAUS(a)                cerr << #a << "=" << a << endl
    #define DEBUG1_CERR_CNIEHAUS(a)                 cerr << a << endl
    #define DEBUG2_CERR_CNIEHAUS(a,b)               cerr << a << b << endl
    #define DEBUG3_CERR_CNIEHAUS(a,b,c)             cerr << a << b << c << endl
    #define DEBUG4_CERR_CNIEHAUS(a,b,c,d)           cerr << a << b << c << d << endl
    #define DEBUG5_CERR_CNIEHAUS(a,b,c,d,e)         cerr << a << b << c << d << e << endl
    #define DEBUG6_CERR_CNIEHAUS(a,b,c,d,e,f)       cerr << a << b << c << d << e << f \
                                                        << endl
    #define DEBUG7_CERR_CNIEHAUS(a,b,c,d,e,f,g)     cerr << a << b << c << d << e << f \
                                                        << g << endl
    #define DEBUG8_CERR_CNIEHAUS(a,b,c,d,e,f,g,h)   cerr << a << b << c << d << e << f \
                                                        << g << h << endl
    #define DEBUG9_CERR_CNIEHAUS(a,b,c,d,e,f,g,h,i) cerr << a << b << c << d << e << f \
                                                        << g << h << i << endl
  #else // !DEBUG_FOR_CNIEHAUS
    #define DUMPVAR_CNIEHAUS(a)                     ;
    #define DEBUG1_CNIEHAUS(a)                      ;
    #define DEBUG2_CNIEHAUS(a,b)                    ;
    #define DEBUG3_CNIEHAUS(a,b,c)                  ;
    #define DEBUG4_CNIEHAUS(a,b,c,d)                ;
    #define DEBUG5_CNIEHAUS(a,b,c,d,e)              ;
    #define DEBUG6_CNIEHAUS(a,b,c,d,e,f)            ;
    #define DEBUG7_CNIEHAUS(a,b,c,d,e,f,g)          ;
    #define DEBUG8_CNIEHAUS(a,b,c,d,e,f,g,h)        ;
    #define DEBUG9_CNIEHAUS(a,b,c,d,e,f,g,h,i)      ;
    #define DUMPVAR_CERR_CNIEHAUS(a)                ;
    #define DEBUG1_CERR_CNIEHAUS(a)                 ;
    #define DEBUG2_CERR_CNIEHAUS(a,b)               ;
    #define DEBUG3_CERR_CNIEHAUS(a,b,c)             ;
    #define DEBUG4_CERR_CNIEHAUS(a,b,c,d)           ;
    #define DEBUG5_CERR_CNIEHAUS(a,b,c,d,e)         ;
    #define DEBUG6_CERR_CNIEHAUS(a,b,c,d,e,f)       ;
    #define DEBUG7_CERR_CNIEHAUS(a,b,c,d,e,f,g)     ;
    #define DEBUG8_CERR_CNIEHAUS(a,b,c,d,e,f,g,h)   ;
    #define DEBUG9_CERR_CNIEHAUS(a,b,c,d,e,f,g,h,i) ;
  #endif //DEBUG_FOR_CNIEHAUS

#if defined (DEBUG_FOR_HARLEKIN)
    #define DUMPVAR_HARLEKIN(a)                     cout << #a << "=" << a << endl
    #define DEBUG1_HARLEKIN(a)                      cout << a << endl
    #define DEBUG2_HARLEKIN(a,b)                    cout << a << b << endl
    #define DEBUG3_HARLEKIN(a,b,c)                  cout << a << b << c << endl
    #define DEBUG4_HARLEKIN(a,b,c,d)                cout << a << b << c << d << endl
    #define DEBUG5_HARLEKIN(a,b,c,d,e)              cout << a << b << c << d << e << endl
    #define DEBUG6_HARLEKIN(a,b,c,d,e,f)            cout << a << b << c << d << e << f \
                                                        << endl
    #define DEBUG7_HARLEKIN(a,b,c,d,e,f,g)          cout << a << b << c << d << e << f \
                                                        << g << endl
    #define DEBUG8_HARLEKIN(a,b,c,d,e,f,g,h)        cout << a << b << c << d << e << f \
                                                        << g << h << endl
    #define DEBUG9_HARLEKIN(a,b,c,d,e,f,g,h,i)      cout << a << b << c << d << e << f \
                                                        << g << h << i << endl
    #define DUMPVAR_CERR_HARLEKIN(a)                cerr << #a << "=" << a << endl
    #define DEBUG1_CERR_HARLEKIN(a)                 cerr << a << endl
    #define DEBUG2_CERR_HARLEKIN(a,b)               cerr << a << b << endl
    #define DEBUG3_CERR_HARLEKIN(a,b,c)             cerr << a << b << c << endl
    #define DEBUG4_CERR_HARLEKIN(a,b,c,d)           cerr << a << b << c << d << endl
    #define DEBUG5_CERR_HARLEKIN(a,b,c,d,e)         cerr << a << b << c << d << e << endl
    #define DEBUG6_CERR_HARLEKIN(a,b,c,d,e,f)       cerr << a << b << c << d << e << f \
                                                        << endl
    #define DEBUG7_CERR_HARLEKIN(a,b,c,d,e,f,g)     cerr << a << b << c << d << e << f \
                                                        << g << endl
    #define DEBUG8_CERR_HARLEKIN(a,b,c,d,e,f,g,h)   cerr << a << b << c << d << e << f \
                                                        << g << h << endl
    #define DEBUG9_CERR_HARLEKIN(a,b,c,d,e,f,g,h,i) cerr << a << b << c << d << e << f \
                                                        << g << h << i << endl
  #else // !DEBUG_FOR_HARLEKIN
    #define DUMPVAR_HARLEKIN(a)                     ;
    #define DEBUG1_HARLEKIN(a)                      ;
    #define DEBUG2_HARLEKIN(a,b)                    ;
    #define DEBUG3_HARLEKIN(a,b,c)                  ;
    #define DEBUG4_HARLEKIN(a,b,c,d)                ;
    #define DEBUG5_HARLEKIN(a,b,c,d,e)              ;
    #define DEBUG6_HARLEKIN(a,b,c,d,e,f)            ;
    #define DEBUG7_HARLEKIN(a,b,c,d,e,f,g)          ;
    #define DEBUG8_HARLEKIN(a,b,c,d,e,f,g,h)        ;
    #define DEBUG9_HARLEKIN(a,b,c,d,e,f,g,h,i)      ;
    #define DUMPVAR_CERR_HARLEKIN(a)                ;
    #define DEBUG1_CERR_HARLEKIN(a)                 ;
    #define DEBUG2_CERR_HARLEKIN(a,b)               ;
    #define DEBUG3_CERR_HARLEKIN(a,b,c)             ;
    #define DEBUG4_CERR_HARLEKIN(a,b,c,d)           ;
    #define DEBUG5_CERR_HARLEKIN(a,b,c,d,e)         ;
    #define DEBUG6_CERR_HARLEKIN(a,b,c,d,e,f)       ;
    #define DEBUG7_CERR_HARLEKIN(a,b,c,d,e,f,g)     ;
    #define DEBUG8_CERR_HARLEKIN(a,b,c,d,e,f,g,h)   ;
    #define DEBUG9_CERR_HARLEKIN(a,b,c,d,e,f,g,h,i) ;
  #endif //DEBUG_FOR_HARLEKIN

 #if defined (DEBUG_FOR_FRITSCHE)
    #define DUMPVAR_FRITSCHE(a)                     cout << #a << "=" << a << endl
    #define DEBUG1_FRITSCHE(a)                      cout << a << endl
    #define DEBUG2_FRITSCHE(a,b)                    cout << a << b << endl
    #define DEBUG3_FRITSCHE(a,b,c)                  cout << a << b << c << endl
    #define DEBUG4_FRITSCHE(a,b,c,d)                cout << a << b << c << d << endl
    #define DEBUG5_FRITSCHE(a,b,c,d,e)              cout << a << b << c << d << e << endl
    #define DEBUG6_FRITSCHE(a,b,c,d,e,f)            cout << a << b << c << d << e << f \
                                                        << endl
    #define DEBUG7_FRITSCHE(a,b,c,d,e,f,g)          cout << a << b << c << d << e << f \
                                                        << g << endl
    #define DEBUG8_FRITSCHE(a,b,c,d,e,f,g,h)        cout << a << b << c << d << e << f \
                                                        << g << h << endl
    #define DEBUG9_FRITSCHE(a,b,c,d,e,f,g,h,i)      cout << a << b << c << d << e << f \
                                                        << g << h << i << endl
    #define DUMPVAR_CERR_FRITSCHE(a)                cerr << #a << "=" << a << endl
    #define DEBUG1_CERR_FRITSCHE(a)                 cerr << a << endl
    #define DEBUG2_CERR_FRITSCHE(a,b)               cerr << a << b << endl
    #define DEBUG3_CERR_FRITSCHE(a,b,c)             cerr << a << b << c << endl
    #define DEBUG4_CERR_FRITSCHE(a,b,c,d)           cerr << a << b << c << d << endl
    #define DEBUG5_CERR_FRITSCHE(a,b,c,d,e)         cerr << a << b << c << d << e << endl
    #define DEBUG6_CERR_FRITSCHE(a,b,c,d,e,f)       cerr << a << b << c << d << e << f \
                                                        << endl
    #define DEBUG7_CERR_FRITSCHE(a,b,c,d,e,f,g)     cerr << a << b << c << d << e << f \
                                                        << g << endl
    #define DEBUG8_CERR_FRITSCHE(a,b,c,d,e,f,g,h)   cerr << a << b << c << d << e << f \
                                                        << g << h << endl
    #define DEBUG9_CERR_FRITSCHE(a,b,c,d,e,f,g,h,i) cerr << a << b << c << d << e << f \
                                                        << g << h << i << endl
  #else // !DEBUG_FOR_FRITSCHE
    #define DUMPVAR_FRITSCHE(a)                     ;
    #define DEBUG1_FRITSCHE(a)                      ;
    #define DEBUG2_FRITSCHE(a,b)                    ;
    #define DEBUG3_FRITSCHE(a,b,c)                  ;
    #define DEBUG4_FRITSCHE(a,b,c,d)                ;
    #define DEBUG5_FRITSCHE(a,b,c,d,e)              ;
    #define DEBUG6_FRITSCHE(a,b,c,d,e,f)            ;
    #define DEBUG7_FRITSCHE(a,b,c,d,e,f,g)          ;
    #define DEBUG8_FRITSCHE(a,b,c,d,e,f,g,h)        ;
    #define DEBUG9_FRITSCHE(a,b,c,d,e,f,g,h,i)      ;
    #define DUMPVAR_CERR_FRITSCHE(a)                ;
    #define DEBUG1_CERR_FRITSCHE(a)                 ;
    #define DEBUG2_CERR_FRITSCHE(a,b)               ;
    #define DEBUG3_CERR_FRITSCHE(a,b,c)             ;
    #define DEBUG4_CERR_FRITSCHE(a,b,c,d)           ;
    #define DEBUG5_CERR_FRITSCHE(a,b,c,d,e)         ;
    #define DEBUG6_CERR_FRITSCHE(a,b,c,d,e,f)       ;
    #define DEBUG7_CERR_FRITSCHE(a,b,c,d,e,f,g)     ;
    #define DEBUG8_CERR_FRITSCHE(a,b,c,d,e,f,g,h)   ;
    #define DEBUG9_CERR_FRITSCHE(a,b,c,d,e,f,g,h,i) ;
  #endif //DEBUG_FOR_FRITSCHE

  #if defined (DEBUG_FOR_TBOGON)
    #define DUMPVAR_TBOGON(a)                     cout << #a << "=" << a << endl
    #define DEBUG1_TBOGON(a)                      cout << a << endl
    #define DEBUG2_TBOGON(a,b)                    cout << a << b << endl
    #define DEBUG3_TBOGON(a,b,c)                  cout << a << b << c << endl
    #define DEBUG4_TBOGON(a,b,c,d)                cout << a << b << c << d << endl
    #define DEBUG5_TBOGON(a,b,c,d,e)              cout << a << b << c << d << e << endl
    #define DEBUG6_TBOGON(a,b,c,d,e,f)            cout << a << b << c << d << e << f \
                                                        << endl
    #define DEBUG7_TBOGON(a,b,c,d,e,f,g)          cout << a << b << c << d << e << f \
                                                        << g << endl
    #define DEBUG8_TBOGON(a,b,c,d,e,f,g,h)        cout << a << b << c << d << e << f \
                                                        << g << h << endl
    #define DEBUG9_TBOGON(a,b,c,d,e,f,g,h,i)      cout << a << b << c << d << e << f \
                                                        << g << h << i << endl
    #define DUMPVAR_CERR_TBOGON(a)                cerr << #a << "=" << a << endl
    #define DEBUG1_CERR_TBOGON(a)                 cerr << a << endl
    #define DEBUG2_CERR_TBOGON(a,b)               cerr << a << b << endl
    #define DEBUG3_CERR_TBOGON(a,b,c)             cerr << a << b << c << endl
    #define DEBUG4_CERR_TBOGON(a,b,c,d)           cerr << a << b << c << d << endl
    #define DEBUG5_CERR_TBOGON(a,b,c,d,e)         cerr << a << b << c << d << e << endl
    #define DEBUG6_CERR_TBOGON(a,b,c,d,e,f)       cerr << a << b << c << d << e << f \
                                                        << endl
    #define DEBUG7_CERR_TBOGON(a,b,c,d,e,f,g)     cerr << a << b << c << d << e << f \
                                                        << g << endl
    #define DEBUG8_CERR_TBOGON(a,b,c,d,e,f,g,h)   cerr << a << b << c << d << e << f \
                                                        << g << h << endl
    #define DEBUG9_CERR_TBOGON(a,b,c,d,e,f,g,h,i) cerr << a << b << c << d << e << f \
                                                        << g << h << i << endl
  #else // !DEBUG_FOR_TBOGON
    #define DUMPVAR_TBOGON(a)                     ;
    #define DEBUG1_TBOGON(a)                      ;
    #define DEBUG2_TBOGON(a,b)                    ;
    #define DEBUG3_TBOGON(a,b,c)                  ;
    #define DEBUG4_TBOGON(a,b,c,d)                ;
    #define DEBUG5_TBOGON(a,b,c,d,e)              ;
    #define DEBUG6_TBOGON(a,b,c,d,e,f)            ;
    #define DEBUG7_TBOGON(a,b,c,d,e,f,g)          ;
    #define DEBUG8_TBOGON(a,b,c,d,e,f,g,h)        ;
    #define DEBUG9_TBOGON(a,b,c,d,e,f,g,h,i)      ;
    #define DUMPVAR_CERR_TBOGON(a)                ;
    #define DEBUG1_CERR_TBOGON(a)                 ;
    #define DEBUG2_CERR_TBOGON(a,b)               ;
    #define DEBUG3_CERR_TBOGON(a,b,c)             ;
    #define DEBUG4_CERR_TBOGON(a,b,c,d)           ;
    #define DEBUG5_CERR_TBOGON(a,b,c,d,e)         ;
    #define DEBUG6_CERR_TBOGON(a,b,c,d,e,f)       ;
    #define DEBUG7_CERR_TBOGON(a,b,c,d,e,f,g)     ;
    #define DEBUG8_CERR_TBOGON(a,b,c,d,e,f,g,h)   ;
    #define DEBUG9_CERR_TBOGON(a,b,c,d,e,f,g,h,i) ;
  #endif //DEBUG_FOR_TBOGON

#if defined (DEBUG_FOR_MOSH)
    #define DUMPVAR_MOSH(a)                     cout << #a << "=" << a << endl
    #define DEBUG1_MOSH(a)                      cout << a << endl
    #define DEBUG2_MOSH(a,b)                    cout << a << b << endl
    #define DEBUG3_MOSH(a,b,c)                  cout << a << b << c << endl
    #define DEBUG4_MOSH(a,b,c,d)                cout << a << b << c << d << endl
    #define DEBUG5_MOSH(a,b,c,d,e)              cout << a << b << c << d << e << endl
    #define DEBUG6_MOSH(a,b,c,d,e,f)            cout << a << b << c << d << e << f \
                                                        << endl
    #define DEBUG7_MOSH(a,b,c,d,e,f,g)          cout << a << b << c << d << e << f \
                                                        << g << endl
    #define DEBUG8_MOSH(a,b,c,d,e,f,g,h)        cout << a << b << c << d << e << f \
                                                        << g << h << endl
    #define DEBUG9_MOSH(a,b,c,d,e,f,g,h,i)      cout << a << b << c << d << e << f \
                                                        << g << h << i << endl
    #define DUMPVAR_CERR_MOSH(a)                cerr << #a << "=" << a << endl
    #define DEBUG1_CERR_MOSH(a)                 cerr << a << endl
    #define DEBUG2_CERR_MOSH(a,b)               cerr << a << b << endl
    #define DEBUG3_CERR_MOSH(a,b,c)             cerr << a << b << c << endl
    #define DEBUG4_CERR_MOSH(a,b,c,d)           cerr << a << b << c << d << endl
    #define DEBUG5_CERR_MOSH(a,b,c,d,e)         cerr << a << b << c << d << e << endl
    #define DEBUG6_CERR_MOSH(a,b,c,d,e,f)       cerr << a << b << c << d << e << f \
                                                        << endl
    #define DEBUG7_CERR_MOSH(a,b,c,d,e,f,g)     cerr << a << b << c << d << e << f \
                                                        << g << endl
    #define DEBUG8_CERR_MOSH(a,b,c,d,e,f,g,h)   cerr << a << b << c << d << e << f \
                                                        << g << h << endl
    #define DEBUG9_CERR_MOSH(a,b,c,d,e,f,g,h,i) cerr << a << b << c << d << e << f \
                                                        << g << h << i << endl
  #else // !DEBUG_FOR_MOSH
    #define DUMPVAR_MOSH(a)                     ;
    #define DEBUG1_MOSH(a)                      ;
    #define DEBUG2_MOSH(a,b)                    ;
    #define DEBUG3_MOSH(a,b,c)                  ;
    #define DEBUG4_MOSH(a,b,c,d)                ;
    #define DEBUG5_MOSH(a,b,c,d,e)              ;
    #define DEBUG6_MOSH(a,b,c,d,e,f)            ;
    #define DEBUG7_MOSH(a,b,c,d,e,f,g)          ;
    #define DEBUG8_MOSH(a,b,c,d,e,f,g,h)        ;
    #define DEBUG9_MOSH(a,b,c,d,e,f,g,h,i)      ;
    #define DUMPVAR_CERR_MOSH(a)                ;
    #define DEBUG1_CERR_MOSH(a)                 ;
    #define DEBUG2_CERR_MOSH(a,b)               ;
    #define DEBUG3_CERR_MOSH(a,b,c)             ;
    #define DEBUG4_CERR_MOSH(a,b,c,d)           ;
    #define DEBUG5_CERR_MOSH(a,b,c,d,e)         ;
    #define DEBUG6_CERR_MOSH(a,b,c,d,e,f)       ;
    #define DEBUG7_CERR_MOSH(a,b,c,d,e,f,g)     ;
    #define DEBUG8_CERR_MOSH(a,b,c,d,e,f,g,h)   ;
    #define DEBUG9_CERR_MOSH(a,b,c,d,e,f,g,h,i) ;
  #endif //DEBUG_FOR_MOSH

#if defined (DEBUG_FOR_WENNS)
    #define DUMPVAR_WENNS(a)                     cout << #a << "=" << a << endl
    #define DEBUG1_WENNS(a)                      cout << a << endl
    #define DEBUG2_WENNS(a,b)                    cout << a << b << endl
    #define DEBUG3_WENNS(a,b,c)                  cout << a << b << c << endl
    #define DEBUG4_WENNS(a,b,c,d)                cout << a << b << c << d << endl
    #define DEBUG5_WENNS(a,b,c,d,e)              cout << a << b << c << d << e << endl
    #define DEBUG6_WENNS(a,b,c,d,e,f)            cout << a << b << c << d << e << f \
                                                      << endl
    #define DEBUG7_WENNS(a,b,c,d,e,f,g)          cout << a << b << c << d << e << f \
                                                      << g << endl
    #define DEBUG8_WENNS(a,b,c,d,e,f,g,h)        cout << a << b << c << d << e << f \
                                                      << g << h << endl
    #define DEBUG9_WENNS(a,b,c,d,e,f,g,h,i)      cout << a << b << c << d << e << f \
                                                      << g << h << i << endl
    #define DUMPVAR_CERR_WENNS(a)                cerr << #a << "=" << a << endl
    #define DEBUG1_CERR_WENNS(a)                 cerr << a << endl
    #define DEBUG2_CERR_WENNS(a,b)               cerr << a << b << endl
    #define DEBUG3_CERR_WENNS(a,b,c)             cerr << a << b << c << endl
    #define DEBUG4_CERR_WENNS(a,b,c,d)           cerr << a << b << c << d << endl
    #define DEBUG5_CERR_WENNS(a,b,c,d,e)         cerr << a << b << c << d << e << endl
    #define DEBUG6_CERR_WENNS(a,b,c,d,e,f)       cerr << a << b << c << d << e << f \
                                                      << endl
    #define DEBUG7_CERR_WENNS(a,b,c,d,e,f,g)     cerr << a << b << c << d << e << f \
                                                      << g << endl
    #define DEBUG8_CERR_WENNS(a,b,c,d,e,f,g,h)   cerr << a << b << c << d << e << f \
                                                      << g << h << endl
    #define DEBUG9_CERR_WENNS(a,b,c,d,e,f,g,h,i) cerr << a << b << c << d << e << f \
                                                      << g << h << i << endl
  #else // !DEBUG_FOR_WENNS
    #define DUMPVAR_WENNS(a)                     ;
    #define DEBUG1_WENNS(a)                      ;
    #define DEBUG2_WENNS(a,b)                    ;
    #define DEBUG3_WENNS(a,b,c)                  ;
    #define DEBUG4_WENNS(a,b,c,d)                ;
    #define DEBUG5_WENNS(a,b,c,d,e)              ;
    #define DEBUG6_WENNS(a,b,c,d,e,f)            ;
    #define DEBUG7_WENNS(a,b,c,d,e,f,g)          ;
    #define DEBUG8_WENNS(a,b,c,d,e,f,g,h)        ;
    #define DEBUG9_WENNS(a,b,c,d,e,f,g,h,i)      ;
    #define DUMPVAR_CERR_WENNS(a)                ;
    #define DEBUG1_CERR_WENNS(a)                 ;
    #define DEBUG2_CERR_WENNS(a,b)               ;
    #define DEBUG3_CERR_WENNS(a,b,c)             ;
    #define DEBUG4_CERR_WENNS(a,b,c,d)           ;
    #define DEBUG5_CERR_WENNS(a,b,c,d,e)         ;
    #define DEBUG6_CERR_WENNS(a,b,c,d,e,f)       ;
    #define DEBUG7_CERR_WENNS(a,b,c,d,e,f,g)     ;
    #define DEBUG8_CERR_WENNS(a,b,c,d,e,f,g,h)   ;
    #define DEBUG9_CERR_WENNS(a,b,c,d,e,f,g,h,i) ;
  #endif //DEBUG_FOR_WENNS

#if defined (DEBUG_FOR_PAGRA)
    #define DUMPVAR_PAGRA(a)                     cout << #a << "=" << a << endl
    #define DEBUG1_PAGRA(a)                      cout << a << endl
    #define DEBUG2_PAGRA(a,b)                    cout << a << b << endl
    #define DEBUG3_PAGRA(a,b,c)                  cout << a << b << c << endl
    #define DEBUG4_PAGRA(a,b,c,d)                cout << a << b << c << d << endl
    #define DEBUG5_PAGRA(a,b,c,d,e)              cout << a << b << c << d << e << endl
    #define DEBUG6_PAGRA(a,b,c,d,e,f)            cout << a << b << c << d << e << f \
                                                      << endl
    #define DEBUG7_PAGRA(a,b,c,d,e,f,g)          cout << a << b << c << d << e << f \
                                                      << g << endl
    #define DEBUG8_PAGRA(a,b,c,d,e,f,g,h)        cout << a << b << c << d << e << f \
                                                      << g << h << endl
    #define DEBUG9_PAGRA(a,b,c,d,e,f,g,h,i)      cout << a << b << c << d << e << f \
                                                      << g << h << i << endl
    #define DUMPVAR_CERR_PAGRA(a)                cerr << #a << "=" << a << endl
    #define DEBUG1_CERR_PAGRA(a)                 cerr << a << endl
    #define DEBUG2_CERR_PAGRA(a,b)               cerr << a << b << endl
    #define DEBUG3_CERR_PAGRA(a,b,c)             cerr << a << b << c << endl
    #define DEBUG4_CERR_PAGRA(a,b,c,d)           cerr << a << b << c << d << endl
    #define DEBUG5_CERR_PAGRA(a,b,c,d,e)         cerr << a << b << c << d << e << endl
    #define DEBUG6_CERR_PAGRA(a,b,c,d,e,f)       cerr << a << b << c << d << e << f \
                                                      << endl
    #define DEBUG7_CERR_PAGRA(a,b,c,d,e,f,g)     cerr << a << b << c << d << e << f \
                                                      << g << endl
    #define DEBUG8_CERR_PAGRA(a,b,c,d,e,f,g,h)   cerr << a << b << c << d << e << f \
                                                      << g << h << endl
    #define DEBUG9_CERR_PAGRA(a,b,c,d,e,f,g,h,i) cerr << a << b << c << d << e << f \
                                                      << g << h << i << endl
  #else // !DEBUG_FOR_PAGRA
    #define DUMPVAR_PAGRA(a)                     ;
    #define DEBUG1_PAGRA(a)                      ;
    #define DEBUG2_PAGRA(a,b)                    ;
    #define DEBUG3_PAGRA(a,b,c)                  ;
    #define DEBUG4_PAGRA(a,b,c,d)                ;
    #define DEBUG5_PAGRA(a,b,c,d,e)              ;
    #define DEBUG6_PAGRA(a,b,c,d,e,f)            ;
    #define DEBUG7_PAGRA(a,b,c,d,e,f,g)          ;
    #define DEBUG8_PAGRA(a,b,c,d,e,f,g,h)        ;
    #define DEBUG9_PAGRA(a,b,c,d,e,f,g,h,i)      ;
    #define DUMPVAR_CERR_PAGRA(a)                ;
    #define DEBUG1_CERR_PAGRA(a)                 ;
    #define DEBUG2_CERR_PAGRA(a,b)               ;
    #define DEBUG3_CERR_PAGRA(a,b,c)             ;
    #define DEBUG4_CERR_PAGRA(a,b,c,d)           ;
    #define DEBUG5_CERR_PAGRA(a,b,c,d,e)         ;
    #define DEBUG6_CERR_PAGRA(a,b,c,d,e,f)       ;
    #define DEBUG7_CERR_PAGRA(a,b,c,d,e,f,g)     ;
    #define DEBUG8_CERR_PAGRA(a,b,c,d,e,f,g,h)   ;
    #define DEBUG9_CERR_PAGRA(a,b,c,d,e,f,g,h,i) ;
  #endif //DEBUG_FOR_PAGRA


#if defined (DEBUG_FOR_KHUEBNER)
    #define DUMPVAR_KHUEBNER(a)                     cout << #a << "=" << a << endl
    #define DEBUG1_KHUEBNER(a)                      cout << a << endl
    #define DEBUG2_KHUEBNER(a,b)                    cout << a << b << endl
    #define DEBUG3_KHUEBNER(a,b,c)                  cout << a << b << c << endl
    #define DEBUG4_KHUEBNER(a,b,c,d)                cout << a << b << c << d << endl
    #define DEBUG5_KHUEBNER(a,b,c,d,e)              cout << a << b << c << d << e << endl
    #define DEBUG6_KHUEBNER(a,b,c,d,e,f)            cout << a << b << c << d << e << f \
                                                      << endl
    #define DEBUG7_KHUEBNER(a,b,c,d,e,f,g)          cout << a << b << c << d << e << f \
                                                      << g << endl
    #define DEBUG8_KHUEBNER(a,b,c,d,e,f,g,h)        cout << a << b << c << d << e << f \
                                                      << g << h << endl
    #define DEBUG9_KHUEBNER(a,b,c,d,e,f,g,h,i)      cout << a << b << c << d << e << f \
                                                      << g << h << i << endl
    #define DUMPVAR_CERR_KHUEBNER(a)                cerr << #a << "=" << a << endl
    #define DEBUG1_CERR_KHUEBNER(a)                 cerr << a << endl
    #define DEBUG2_CERR_KHUEBNER(a,b)               cerr << a << b << endl
    #define DEBUG3_CERR_KHUEBNER(a,b,c)             cerr << a << b << c << endl
    #define DEBUG4_CERR_KHUEBNER(a,b,c,d)           cerr << a << b << c << d << endl
    #define DEBUG5_CERR_KHUEBNER(a,b,c,d,e)         cerr << a << b << c << d << e << endl
    #define DEBUG6_CERR_KHUEBNER(a,b,c,d,e,f)       cerr << a << b << c << d << e << f \
                                                      << endl
    #define DEBUG7_CERR_KHUEBNER(a,b,c,d,e,f,g)     cerr << a << b << c << d << e << f \
                                                      << g << endl
    #define DEBUG8_CERR_KHUEBNER(a,b,c,d,e,f,g,h)   cerr << a << b << c << d << e << f \
                                                      << g << h << endl
    #define DEBUG9_CERR_KHUEBNER(a,b,c,d,e,f,g,h,i) cerr << a << b << c << d << e << f \
                                                      << g << h << i << endl
  #else // !DEBUG_FOR_KHUEBNER
    #define DUMPVAR_KHUEBNER(a)                     ;
    #define DEBUG1_KHUEBNER(a)                      ;
    #define DEBUG2_KHUEBNER(a,b)                    ;
    #define DEBUG3_KHUEBNER(a,b,c)                  ;
    #define DEBUG4_KHUEBNER(a,b,c,d)                ;
    #define DEBUG5_KHUEBNER(a,b,c,d,e)              ;
    #define DEBUG6_KHUEBNER(a,b,c,d,e,f)            ;
    #define DEBUG7_KHUEBNER(a,b,c,d,e,f,g)          ;
    #define DEBUG8_KHUEBNER(a,b,c,d,e,f,g,h)        ;
    #define DEBUG9_KHUEBNER(a,b,c,d,e,f,g,h,i)      ;
    #define DUMPVAR_CERR_KHUEBNER(a)                ;
    #define DEBUG1_CERR_KHUEBNER(a)                 ;
    #define DEBUG2_CERR_KHUEBNER(a,b)               ;
    #define DEBUG3_CERR_KHUEBNER(a,b,c)             ;
    #define DEBUG4_CERR_KHUEBNER(a,b,c,d)           ;
    #define DEBUG5_CERR_KHUEBNER(a,b,c,d,e)         ;
    #define DEBUG6_CERR_KHUEBNER(a,b,c,d,e,f)       ;
    #define DEBUG7_CERR_KHUEBNER(a,b,c,d,e,f,g)     ;
    #define DEBUG8_CERR_KHUEBNER(a,b,c,d,e,f,g,h)   ;
    #define DEBUG9_CERR_KHUEBNER(a,b,c,d,e,f,g,h,i) ;
  #endif //DEBUG_FOR_KHUEBNER


  #if defined (DEBUG_FOR_SYNCHRO)
    #define DUMPVAR_SYNCHRO(a)                cout << #a << "=" << a << endl
    #define DEBUG1_SYNCHRO(a)                 cout << a << endl
    #define DEBUG2_SYNCHRO(a,b)               cout << a << b << endl
    #define DEBUG3_SYNCHRO(a,b,c)             cout << a << b << c << endl
    #define DEBUG4_SYNCHRO(a,b,c,d)           cout << a << b << c << d << endl
    #define DEBUG5_SYNCHRO(a,b,c,d,e)         cout << a << b << c << d << e << endl
    #define DEBUG6_SYNCHRO(a,b,c,d,e,f)       cout << a << b << c << d << e << f \
                                                   << endl
    #define DEBUG7_SYNCHRO(a,b,c,d,e,f,g)     cout << a << b << c << d << e << f \
                                                   << g << endl
    #define DEBUG8_SYNCHRO(a,b,c,d,e,f,g,h)   cout << a << b << c << d << e << f \
                                                   << g << h << endl
    #define DEBUG9_SYNCHRO(a,b,c,d,e,f,g,h,i) cout << a << b << c << d << e << f \
                                                   << g << h << i << endl
  #else // !DEBUG_FOR_SYNCHRO
    #define DUMPVAR_SYNCHRO(a)                     ;
    #define DEBUG1_SYNCHRO(a)                      ;
    #define DEBUG2_SYNCHRO(a,b)                    ;
    #define DEBUG3_SYNCHRO(a,b,c)                  ;
    #define DEBUG4_SYNCHRO(a,b,c,d)                ;
    #define DEBUG5_SYNCHRO(a,b,c,d,e)              ;
    #define DEBUG6_SYNCHRO(a,b,c,d,e,f)            ;
    #define DEBUG7_SYNCHRO(a,b,c,d,e,f,g)          ;
    #define DEBUG8_SYNCHRO(a,b,c,d,e,f,g,h)        ;
    #define DEBUG9_SYNCHRO(a,b,c,d,e,f,g,h,i)      ;
  #endif //DEBUG_FOR_SYNCHRO

  #if defined (DEBUG_FOR_AW)
    #define DUMPVAR_AW(a)                     cout << #a << "=" << a << endl
    #define DEBUG1_AW(a)                      cout << a << endl
    #define DEBUG2_AW(a,b)                    cout << a << b << endl
    #define DEBUG3_AW(a,b,c)                  cout << a << b << c << endl
    #define DEBUG4_AW(a,b,c,d)                cout << a << b << c << d << endl
    #define DEBUG5_AW(a,b,c,d,e)              cout << a << b << c << d << e << endl
    #define DEBUG6_AW(a,b,c,d,e,f)            cout << a << b << c << d << e << f \
                                                        << endl
    #define DEBUG7_AW(a,b,c,d,e,f,g)          cout << a << b << c << d << e << f \
                                                        << g << endl
    #define DEBUG8_AW(a,b,c,d,e,f,g,h)        cout << a << b << c << d << e << f \
                                                        << g << h << endl
    #define DEBUG9_AW(a,b,c,d,e,f,g,h,i)      cout << a << b << c << d << e << f \
                                                        << g << h << i << endl
    #define DUMPVAR_CERR_AW(a)                cerr << #a << "=" << a << endl
    #define DEBUG1_CERR_AW(a)                 cerr << a << endl
    #define DEBUG2_CERR_AW(a,b)               cerr << a << b << endl
    #define DEBUG3_CERR_AW(a,b,c)             cerr << a << b << c << endl
    #define DEBUG4_CERR_AW(a,b,c,d)           cerr << a << b << c << d << endl
    #define DEBUG5_CERR_AW(a,b,c,d,e)         cerr << a << b << c << d << e << endl
    #define DEBUG6_CERR_AW(a,b,c,d,e,f)       cerr << a << b << c << d << e << f \
                                                        << endl
    #define DEBUG7_CERR_AW(a,b,c,d,e,f,g)     cerr << a << b << c << d << e << f \
                                                        << g << endl
    #define DEBUG8_CERR_AW(a,b,c,d,e,f,g,h)   cerr << a << b << c << d << e << f \
                                                        << g << h << endl
    #define DEBUG9_CERR_AW(a,b,c,d,e,f,g,h,i) cerr << a << b << c << d << e << f \
                                                        << g << h << i << endl
  #else // !DEBUG_FOR_AW
    #define DUMPVAR_AW(a)                     ;
    #define DEBUG1_AW(a)                      ;
    #define DEBUG2_AW(a,b)                    ;
    #define DEBUG3_AW(a,b,c)                  ;
    #define DEBUG4_AW(a,b,c,d)                ;
    #define DEBUG5_AW(a,b,c,d,e)              ;
    #define DEBUG6_AW(a,b,c,d,e,f)            ;
    #define DEBUG7_AW(a,b,c,d,e,f,g)          ;
    #define DEBUG8_AW(a,b,c,d,e,f,g,h)        ;
    #define DEBUG9_AW(a,b,c,d,e,f,g,h,i)      ;
    #define DUMPVAR_CERR_AW(a)                ;
    #define DEBUG1_CERR_AW(a)                 ;
    #define DEBUG2_CERR_AW(a,b)               ;
    #define DEBUG3_CERR_AW(a,b,c)             ;
    #define DEBUG4_CERR_AW(a,b,c,d)           ;
    #define DEBUG5_CERR_AW(a,b,c,d,e)         ;
    #define DEBUG6_CERR_AW(a,b,c,d,e,f)       ;
    #define DEBUG7_CERR_AW(a,b,c,d,e,f,g)     ;
    #define DEBUG8_CERR_AW(a,b,c,d,e,f,g,h)   ;
    #define DEBUG9_CERR_AW(a,b,c,d,e,f,g,h,i) ;
  #endif //DEBUG_FOR_AW
      
#endif // DEBUG_HH

// $Source: /home/robocup/virtualwerder/CVSRepository/VirtualWerder2004/debug.hh,v $
