%{
#include <iostream>

#include "ConfFileData.hh"

void yyerror(const char *s);
extern int yylex();
extern char *yytext;
%}

%union
{
	int     lval;
	double	dval;
	char*	chars;
}

%token 	<lval> 		ERROR

%token 	<lval> 		LONG
%token 	<dval>		DOUBLE
%token	<chars>		CHARS
%token  <chars>		COMMENTLINE
%token  <lval>		EMPTYLINE

%token	<chars>		NAME
%token	<lval>		COLON

%type <lval>	configlines;
%type <lval>	configline;

%start		configlines

%token 	<lval>	KW_LONG
%token 	<lval>	KW_DOUBLE
%token 	<lval>	KW_STRING

%%

configline:	  KW_LONG   NAME LONG
		{ ConfFileData::addVariableLong($2,$3); }
		| KW_DOUBLE NAME LONG
		{ ConfFileData::addVariableDouble($2,(double)$3); }
		| KW_DOUBLE NAME DOUBLE
		{ ConfFileData::addVariableDouble($2,$3); }
		| KW_STRING NAME CHARS
		{ ConfFileData::addVariableString($2,$3); }
		| COMMENTLINE
		{ ConfFileData::addComment($1); }
		| EMPTYLINE
		{ ConfFileData::addEmpty(); }
                ;

configlines:	  configlines configline
		| configline
                ;

%%

void yyerror (const char* s )
{
  cerr << __FILE__ << ": <" << s << "> occured while parsing <" << yytext
	<< ">" << endl;
}
