/* flex file */

%{
//---------------------   C definitions    --------------------------
#include <string.h>
#include "player_lang.tab.h"

#define YY_DECL int ss_lex ( YYSTYPE *lval )

#define BUFFER_SIZE 2048
char buffer[BUFFER_SIZE];
%}
/*-------------------- flex definitions ----------------------------*/

/*%option debug*/
/*%option yylineno*/
%option prefix="ss_"
%option nostdinit
%option nounput
%option noyywrap

UINT [0-9]+
INT  [\+\-]?{UINT}
REAL [\+\-]?{UINT}?\.{UINT}
EXP  ({REAL}|{INT})[eE]{INT}
STR  [a-zA-Z_]
QSTR \"[^\"]*\"

WS   [ \t\n]+

LP   \(
RP   \)

CLANGHEAD {LP}hear{WS}{INT}{WS}online_coach_((left)|(right)){WS}{INT}{WS}{LP}
CLANGTAIL {RP}

CLANG     {CLANGHEAD}.*{CLANGTAIL}

%%

{WS} /* skip white space */

{LP} { return LP; }
{RP} { return RP; }

init         { return INIT; }

server_param                   { return SERVPARA; }
catch_ban_cycle                { return  CATCH_BAN_CYCLE     ; }
clang_advice_win               { return  CLANG_ADVICE_WIN    ; }
clang_define_win               { return  CLANG_DEFINE_WIN    ; }
clang_del_win                  { return  CLANG_DEL_WIN       ; }
clang_info_win                 { return  CLANG_INFO_WIN      ; }
clang_mess_delay               { return  CLANG_MESS_DELAY    ; }
clang_mess_per_cycle           { return  CLANG_MESS_PER_CYCLE; }
clang_meta_win                 { return  CLANG_META_WIN      ; }
clang_rule_win                 { return  CLANG_RULE_WIN      ; }
clang_win_size                 { return  CLANG_WIN_SIZE      ; }
coach_port                     { return  COACH_PORT          ; }
drop_ball_time                 { return  DROP_BALL_TIME      ; }
freeform_send_period           { return  FREEFORM_SEND_PERIOD; }
freeform_wait_period           { return  FREEFORM_WAIT_PERIOD; }
game_log_compression           { return  GAME_LOG_COMPRESSION; }
game_log_version               { return  GAME_LOG_VERSION    ; }
goalie_max_moves               { return  GOALIE_MAX_MOVES    ; }
half_time                      { return  HALF_TIME           ; }
hear_decay                     { return  HEAR_DECAY          ; }
hear_inc                       { return  HEAR_INC            ; }
hear_max                       { return  HEAR_MAX            ; }
max_goal_kicks                 { return  MAX_GOAL_KICKS      ; }
olcoach_port                   { return  OLCOACH_PORT        ; }
point_to_ban                   { return  POINT_TO_BAN        ; }
point_to_duration              { return  POINT_TO_DURATION   ; }
port                           { return  PORT                ; }
recv_step                      { return  RECV_STEP           ; }
say_coach_cnt_max              { return  SAY_COACH_CNT_MAX   ; }
say_coach_msg_size             { return  SAY_COACH_MSG_SIZE  ; }
say_msg_size                   { return  SAY_MSG_SIZE        ; }
send_step                      { return  SEND_STEP           ; }
send_vi_step                   { return  SEND_VI_STEP        ; }
sense_body_step                { return  SENSE_BODY_STEP     ; }
simulator_step                 { return  SIMULATOR_STEP      ; }
slow_down_factor               { return  SLOW_DOWN_FACTOR    ; }
start_goal_l                   { return  START_GOAL_L        ; }
start_goal_r                   { return  START_GOAL_R        ; }
synch_micro_sleep              { return  SYNCH_MICRO_SLEEP   ; }
synch_offset                   { return  SYNCH_OFFSET        ; }
tackle_cycles                  { return  TACKLE_CYCLES       ; }
text_log_compression           { return  TEXT_LOG_COMPRESSION; }
game_log_dir                   { return  GAME_LOG_DIR        ; }
game_log_fixed_name            { return  GAME_LOG_FIXED_NAME ; }
landmark_file                  { return  LANDMARK_FILE       ; }
log_date_format                { return  LOG_DATE_FORMAT     ; }
text_log_dir                   { return  TEXT_LOG_DIR        ; }
text_log_fixed_name            { return  TEXT_LOG_FIXED_NAME ; }
coach                          { return  COACH               ; }
coach_w_referee                { return  COACH_W_REFEREE     ; }
old_coach_hear                 { return  OLD_COACH_HEAR          ; }
wind_none                      { return  WIND_NONE               ; }
wind_random                    { return  WIND_RANDOM             ; }
back_passes                    { return  BACK_PASSES             ; }
forbid_kick_off_offside        { return  FORBID_KICK_OFF_OFFSIDE ; }
free_kick_faults               { return  FREE_KICK_FAULTS        ; }
fullstate_l                    { return  FULLSTATE_L             ; }
fullstate_r                    { return  FULLSTATE_R             ; }
game_log_dated                 { return  GAME_LOG_DATED          ; }
game_log_fixed                 { return  GAME_LOG_FIXED          ; }
game_logging                   { return  GAME_LOGGING            ; }
log_times                      { return  LOG_TIMES               ; }
profile                        { return  PROFILE                 ; }
proper_goal_kicks              { return  PROPER_GOAL_KICKS       ; }
record_messages                { return  RECORD_MESSAGES         ; }
send_comms                     { return  SEND_COMMS              ; }
synch_mode                     { return  SYNCH_MODE              ; }
team_actuator_noise            { return  TEAM_ACTUATOR_NOISE     ; }
text_log_dated                 { return  TEXT_LOG_DATED          ; }
text_log_fixed                 { return  TEXT_LOG_FIXED          ; }
text_logging                   { return  TEXT_LOGGING            ; }
use_offside                    { return  USE_OFFSIDE             ; }
verbose                        { return  VERBOSE                 ; }
audio_cut_dist                 { return  AUDIO_CUT_DIST          ; }
ball_accel_max                 { return  BALL_ACCEL_MAX          ; }
ball_decay                     { return  BALL_DECAY              ; }
ball_rand                      { return  BALL_RAND               ; }
ball_size                      { return  BALL_SIZE               ; }
ball_speed_max                 { return  BALL_SPEED_MAX          ; }
ball_weight                    { return  BALL_WEIGHT             ; }
catch_probability              { return  CATCH_PROBABILITY       ; }
catchable_area_l               { return  CATCHABLE_AREA_L        ; }
catchable_area_w               { return  CATCHABLE_AREA_W        ; }
ckick_margin                   { return  CKICK_MARGIN            ; }
control_radius                 { return  CONTROL_RADIUS          ; }
dash_power_rate                { return  DASH_POWER_RATE         ; }
effort_dec                     { return  EFFORT_DEC              ; }
effort_dec_thr                 { return  EFFORT_DEC_THR          ; }
effort_inc                     { return  EFFORT_INC              ; }
effort_inc_thr                 { return  EFFORT_INC_THR          ; }
effort_init                    { return  EFFORT_INIT             ; }
effort_min                     { return  EFFORT_MIN              ; }
goal_width                     { return  GOAL_WIDTH              ; }
inertia_moment                 { return  INERTIA_MOMENT          ; }
kick_power_rate                { return  KICK_POWER_RATE         ; }
kick_rand                      { return  KICK_RAND               ; }
kick_rand_factor_l             { return  KICK_RAND_FACTOR_L      ; }
kick_rand_factor_r             { return  KICK_RAND_FACTOR_R      ; }
kickable_margin                { return  KICKABLE_MARGIN         ; }
maxmoment                      { return  MAXMOMENT               ; }
maxneckang                     { return  MAXNECKANG              ; }
maxneckmoment                  { return  MAXNECKMOMENT           ; }
maxpower                       { return  MAXPOWER                ; }
minmoment                      { return  MINMOMENT               ; }
minneckang                     { return  MINNECKANG              ; }
minneckmoment                  { return  MINNECKMOMENT           ; }
minpower                       { return  MINPOWER                ; }
offside_active_area_size       { return  OFFSIDE_ACTIVE_AREA_SIZE; }
offside_kick_margin            { return  OFFSIDE_KICK_MARGIN     ; }
player_accel_max               { return  PLAYER_ACCEL_MAX        ; }
player_decay                   { return  PLAYER_DECAY            ; }
player_rand                    { return  PLAYER_RAND             ; }
player_size                    { return  PLAYER_SIZE             ; }
player_speed_max               { return  PLAYER_SPEED_MAX        ; }
player_weight                  { return  PLAYER_WEIGHT           ; }
prand_factor_l                 { return  PRAND_FACTOR_L          ; }
prand_factor_r                 { return  PRAND_FACTOR_R          ; }
quantize_step                  { return  QUANTIZE_STEP           ; }
quantize_step_l                { return  QUANTIZE_STEP_L         ; }
recover_dec                    { return  RECOVER_DEC             ; }
recover_dec_thr                { return  RECOVER_DEC_THR                ; }
recover_min                    { return  RECOVER_MIN                    ; }
slowness_on_top_for_left_team  { return  SLOWNESS_ON_TOP_FOR_LEFT_TEAM  ; }
slowness_on_top_for_right_team { return  SLOWNESS_ON_TOP_FOR_RIGHT_TEAM ; }
stamina_inc_max                { return  STAMINA_INC_MAX                ; }
stamina_max                    { return  STAMINA_MAX                    ; }
stopped_ball_vel               { return  STOPPED_BALL_VEL               ; }
tackle_back_dist               { return  TACKLE_BACK_DIST               ; }
tackle_dist                    { return  TACKLE_DIST                    ; }
tackle_exponent                { return  TACKLE_EXPONENT                ; }
tackle_power_rate              { return  TACKLE_POWER_RATE              ; }
tackle_width                   { return  TACKLE_WIDTH                   ; }
visible_angle                  { return  VISIBLE_ANGLE                  ; }
visible_distance               { return  VISIBLE_DISTANCE               ; }
wind_ang                       { return  WIND_ANG                       ; }
wind_dir                       { return  WIND_DIR                       ; }
wind_force                     { return  WIND_FORCE                     ; }
wind_rand                      { return  WIND_RAND                      ; }


player_param                     { return PLAYPARA; }
player_types                     { return PLAYER_TYPES                    ; }
pt_max                           { return PT_MAX                          ; }
random_seed                      { return RANDOM_SEED                     ; }
subs_max                         { return SUBS_MAX                        ; }
dash_power_rate_delta_max        { return DASH_POWER_RATE_DELTA_MAX       ; }
dash_power_rate_delta_min        { return DASH_POWER_RATE_DELTA_MIN       ; }
effort_max_delta_factor          { return EFFORT_MAX_DELTA_FACTOR         ; }
effort_min_delta_factor          { return EFFORT_MIN_DELTA_FACTOR         ; }
extra_stamina_delta_max          { return EXTRA_STAMINA_DELTA_MAX         ; }
extra_stamina_delta_min          { return EXTRA_STAMINA_DELTA_MIN         ; }
inertia_moment_delta_factor      { return INERTIA_MOMENT_DELTA_FACTOR     ; }
kick_rand_delta_factor           { return KICK_RAND_DELTA_FACTOR          ; }
kickable_margin_delta_max        { return KICKABLE_MARGIN_DELTA_MAX       ; }
kickable_margin_delta_min        { return KICKABLE_MARGIN_DELTA_MIN       ; }
new_dash_power_rate_delta_max    { return NEW_DASH_POWER_RATE_DELTA_MAX   ; }
new_dash_power_rate_delta_min    { return NEW_DASH_POWER_RATE_DELTA_MIN   ; }
new_stamina_inc_max_delta_factor { return NEW_STAMINA_INC_MAX_DELTA_FACTOR; }
player_decay_delta_max           { return PLAYER_DECAY_DELTA_MAX          ; }
player_decay_delta_min           { return PLAYER_DECAY_DELTA_MIN          ; }
player_size_delta_factor         { return PLAYER_SIZE_DELTA_FACTOR        ; }
player_speed_max_delta_max       { return PLAYER_SPEED_MAX_DELTA_MAX      ; }
player_speed_max_delta_min       { return PLAYER_SPEED_MAX_DELTA_MIN      ; }
stamina_inc_max_delta_factor     { return STAMINA_INC_MAX_DELTA_FACTOR    ; }


player_type      { return PLAYTYPE; }
id               { return ID              ; }
extra_stamina    { return EXTRA_STAMINA   ; }
effort_max       { return EFFORT_MAX      ; }


sense_body  { return SENSE_BODY; }
view_mode   { return VIEW_MODE; }
high        { return HIGH; }
low         { return LOW; }
narrow      { return NARROW; }
normal      { return NORMAL; }
wide        { return WIDE; }
stamina     { return STAMINA; }
speed       { return SPEED; }
head_angle  { return HEAD_ANGLE; }
kick        { return KICK; }
dash        { return DASH; }
turn        { return TURN; }
say         { return SAY; }
turn_neck   { return TURN_NECK; }
catch       { return CATCH; }
move        { return MOVE; }
change_view { return CHANGE_VIEW; }
arm         { return ARM; }
focus       { return FOCUS; }
tackle      { return TACKLE; }
movable     { return MOVABLE; }
expires     { return EXPIRES; }
target      { return TARGET; }
count       { return COUNT; }
none        { return NONE; }

clang      { return CLANG_OK; } /* use this in ok message cause CLANG is already used */

see        { return SEE; }
see_global { return SEE_GLOBAL; }
p          { return P; }  /* player or penalty */
b          { return B; }  /* ball or bottom */
g          { return G; }  /* goal */
f          { return F; }  /* flag */
l          { return L; }  /* line or left */
B          { return BB; } /* unrecognized ball */
F          { return BF; } /* unrecognized flag */
G          { return BG; } /* unrecognized goal */
P          { return BP; } /* unrecognized player */
c          { return C; }  /* center */
r          { return R; }  /* right */
t          { return T; }  /* top */


fullstate   { return FULLSTATE;  }
pmode       { return PMODE;      }
vmode       { return VMODE;      }


hear                { return HEAR; }
referee             { return REFEREE; }
self                { return SELF; }
goalie              { return GOALIE; }
online_coach_left   { return ONLINE_COACH_LEFT; }
online_coach_right  { return ONLINE_COACH_RIGHT; }

{CLANG} { strncpy(buffer, yytext, BUFFER_SIZE); lval->str = buffer;
          return CLANG; }

change_player_type      { return CHANGE; }
freeform                { return FREEFORM; }

cant                               { return CANT                              ; }
error                              { return ERROR                             ; }
no_more_team_or_player_or_goalie   { return NO_MORE_TEAM_OR_PLAYER_OR_GOALIE  ; }
no_such_team_or_already_have_coach { return NO_SUCH_TEAM_OR_ALREADY_HAVE_COACH; }
too_many_moves                     { return TOO_MANY_MOVES                    ; }
unknown_command                    { return UNKNOWN_COMMAND                   ; }
illegal_command_form               { return ILLEGAL_COMMAND_FORM              ; }
say_message_too_long               { return SAY_MESSAGE_TOO_LONG              ; }
illegal_mode                       { return ILLEGAL_MODE                      ; }
illegal_object_form                { return ILLEGAL_OBJECT_FORM               ; }
said_too_many_freeform_messages    { return SAID_TOO_MANY_FREEFORM_MESSAGES   ; }
cannot_say_freeform_while_playon   { return CANNOT_SAY_FREEFORM_WHILE_PLAYON  ; }
said_too_many_meta_messages        { return SAID_TOO_MANY_META_MESSAGES       ; }
said_too_many_advice_messages      { return SAID_TOO_MANY_ADVICE_MESSAGES     ; }
said_too_many_info_messages        { return SAID_TOO_MANY_INFO_MESSAGES       ; }
said_too_many_define_messages      { return SAID_TOO_MANY_DEFINE_MESSAGES     ; }
could_not_parse_say                { return COULD_NOT_PARSE_SAY               ; }
said_too_many_messages             { return SAID_TOO_MANY_MESSAGES            ; }


warn                             { return WARN                            ; }
no_team_found                    { return NO_TEAM_FOUND                   ; }
no_such_player                   { return NO_SUCH_PLAYER                  ; }
cannot_sub_while_playon          { return CANNOT_SUB_WHILE_PLAYON         ; }
no_subs_left                     { return NO_SUBS_LEFT                    ; }
max_of_that_player_type_on_field { return MAX_OF_THAT_PLAYER_TYPE_ON_FIELD; }
cannot_change_goalie             { return CANNOT_CHANGE_GOALIE            ; }

ok  { return OK;  }
ver { return VER; }
eye { return EYE; }
on  { lval->ival = true;  return ON_OFF; }
off { lval->ival = false; return ON_OFF; }


score       { return SCORE; }
our         { return OUR;        }
opp         { return OPP;        }

before_kick_off        { return BEFORE_KICK_OFF       ; }
time_over              { return TIME_OVER             ; }
play_on                { return PLAY_ON               ; }
kick_off_l             { return KICK_OFF_L            ; }
kick_off_r             { return KICK_OFF_R            ; }
kick_in_l              { return KICK_IN_L             ; }
kick_in_r              { return KICK_IN_R             ; }
free_kick_l            { return FREE_KICK_L           ; }
free_kick_r            { return FREE_KICK_R           ; }
corner_kick_l          { return CORNER_KICK_L         ; }
corner_kick_r          { return CORNER_KICK_R         ; }
goal_kick_l            { return GOAL_KICK_L           ; }
goal_kick_r            { return GOAL_KICK_R           ; }
goal_l                 { return GOAL_L                ; }
goal_r                 { return GOAL_R                ; }
goal_l_{INT}           {
                          lval->ival = atoi(yytext+7);
                          return GOAL_L_INT;
                       }
goal_r_{INT}           {
                          lval->ival = atoi(yytext+7);
                          return GOAL_R_INT;
                       }
drop_ball              { return DROP_BALL             ; }
offside_l              { return OFFSIDE_L             ; }
offside_r              { return OFFSIDE_R             ; }
penalty_kick_l         { return PENALTY_KICK_L        ; }
penalty_kick_r         { return PENALTY_KICK_R        ; }
pause                  { return PAUSE                 ; }
human_judge            { return HUMAN_JUDGE           ; }
foul_l                 { return FOUL_L                ; }
foul_r                 { return FOUL_R                ; }
foul_charge_l          { return FOUL_CHARGE_L         ; }
foul_charge_r          { return FOUL_CHARGE_R         ; }
foul_push_l            { return FOUL_PUSH_L           ; }
foul_push_r            { return FOUL_PUSH_R           ; }
foul_multiple_attack_l { return FOUL_MULTIPLE_ATTACK_L; }
foul_multiple_attack_r { return FOUL_MULTIPLE_ATTACK_R; }
foul_ballout_l         { return FOUL_BALLOUT_L        ; }
foul_ballout_r         { return FOUL_BALLOUT_R        ; }
back_pass_l            { return BACK_PASS_L           ; }
back_pass_r            { return BACK_PASS_R           ; }
free_kick_fault_l      { return FREE_KICK_FAULT_L     ; }
free_kick_fault_r      { return FREE_KICK_FAULT_R     ; }
goalie_catch_ball_l    { return GOALIE_CATCH_BALL_L   ; }
goalie_catch_ball_r    { return GOALIE_CATCH_BALL_R   ; }
time_up                { return TIME_UP               ; }
indirect_free_kick_l   { return INDIRECT_FREE_KICK_L  ; }
indirect_free_kick_r   { return INDIRECT_FREE_KICK_R  ; }
penalty_setup_l        { return PENALTY_SETUP_L       ; }
penalty_setup_r        { return PENALTY_SETUP_R       ; }
penalty_ready_l        { return PENALTY_READY_L       ; }
penalty_ready_r        { return PENALTY_READY_R       ; }
penalty_taken_l        { return PENALTY_TAKEN_L       ; }
penalty_taken_r        { return PENALTY_TAKEN_R       ; }
penalty_miss_l         { return PENALTY_MISS_L        ; }
penalty_miss_r         { return PENALTY_MISS_R        ; }
penalty_score_l        { return PENALTY_SCORE_L       ; }
penalty_score_r        { return PENALTY_SCORE_R       ; }

penalty_onfield_l      { return PENALTY_ONFIELD_L     ; }
penalty_onfield_r      { return PENALTY_ONFIELD_R     ; }

think                  { return THINK                 ; }


{UINT} { lval->ival = atoi(yytext); return INT; }
{INT}  { lval->ival = atoi(yytext); return INT; }
{REAL} { lval->rval = atof(yytext); return FLOAT; }
{EXP}  { lval->rval = atof(yytext); return FLOAT; }
{STR}  { strncpy(buffer, yytext, BUFFER_SIZE); lval->str=buffer; return STR; }
{QSTR} { strncpy(buffer, yytext, BUFFER_SIZE); lval->str=buffer; return QSTR; }


{}  /* catch all rule (??) */

%%
//---------------------   C code section    --------------------------

int ss_parse (void *param);

int parse_msg ( const char *s, void *param ){
  YY_BUFFER_STATE yybuff = yy_scan_string ( s );

  int ret = ss_parse(param);

  yy_delete_buffer ( yybuff );

  return ret;
}

