#ifndef __GOALIE_BEHAVIOUR_H
#define __GOALIE_BEHAVIOUR_H

#include "Agent.hh"
#include "WorldModel.hh"
#include "Geometry.hh"

/** This class models the GoalieBehaviour it extends the general Player Behaviour*/
class GoalieBehaviour : public Behaviour{
	public:
  /** Constructor initializing the Behaviour and calling the super Constructor*/
  GoalieBehaviour();
  /** Destructor doing nothing at the moment*/
  ~GoalieBehaviour();
  /** Handles Free Kicks, e.g. if the Goalie caught the Ball
      @return true if the freeKick was successful, false otherwise
      @todo this should be protected and maybe void
  */
  bool freeKickBehaviour();
  bool switchView();
  void passOrKick();
  void goaliePenaltyBehaviour();
  void goaliePenaltySetup();
  void ourPenGoaliePositioning();
  void sideAttackBehaviour();
  bool sideAttack();

  void doPositioning();
  void goaliePositioning(GoaliePosBehaviour beh, const Vector2D &ballPos);
  void goalieLeftBehaviour(const Vector2D &ballPos);
  void goalieNormBehaviour(const Vector2D &ballPos);
  void goalieRightBehaviour(const Vector2D &ballPos);
  void goalieNothing();
  void goalieTurnBody(const Vector2D &top, 
		      const Vector2D &bottom, 
		      const Vector2D &ballPos, GoaliePosBehaviour beh);
  GoaliePosBehaviour goaliePosBeh(const Vector2D &ballPos);

  const Player* goaliePass();
  bool shouldTryToCatchBall();
  void playOnBehaviour();
    void playOnBehaviour2();
  void goalKickBehaviour();
  bool doPenaltyGoalie();
  void doPenaltyGoaliePositioning(float x);
  void scanFieldWithBodyGoalie(); 
  bool oneTime;

private:

  
  bool scoreGoal;
  int merker;
  int zaehler;
  Vector2D movePoint;
  Time now;
  bool passCand;
  bool viewleft;
  bool viewright;
  int freeKickStep;

  virtual void generalBehaviour();

};

#endif
