#include "WingMidfielderBehaviour.hh"

/** Initializes the Behaviour
    @param leftWing is this the left or the right wing midfielder
*/
WingMidfielderBehaviour::WingMidfielderBehaviour(bool leftWing) : Behaviour()
{
  left = leftWing;
}

/** Destroys the WingMidfielderBehaviour*/
WingMidfielderBehaviour::~WingMidfielderBehaviour()
{
}

/** Handles the Behaviour if the Agent has the Ball (the Ball is kickable)*/
void WingMidfielderBehaviour::playOnWithBall(){
  //Formation *formation = Formations::getCurrentFormation();
  //int unum = myself->getUniformNumber();
  //int myBehaviour = formation->getBehaviour(unum);

  // This should be done if the ball wouldnt be kickable next turn
  // eg. leave the kickable area
  if (ball->getVelocity().isInvalid()){
    skillPool->holdBall();
    skillPool->faceOnlyNeckToBall();
    return;
  }

  if (tryToForceScoreGoal()){
    lookAround(true);
    return;
  }
 
  // Shoot a goal if possible
  if (tryToScoreGoal()){
    lookAround(true);
    return;
  }
  
  //try to Dribble behind enemys Defense
  if(ball->getPosition().getX() > 0){
    static float passSpeed, passPower;
    Vector2D passPoint    = Vector2D(NAN,NAN);
    Vector2D passVelocity = Vector2D(NAN,NAN);
    if(worldModel->canDribbleBehindDefense(passPoint,passVelocity)){
      passSpeed = passVelocity.getLength();
      passPower = worldModel->calcKickPowerForSpeed( passSpeed );
      skillPool->kickToPoint( passPoint, passPower, false );      
      return;
    }
  }
  

  if (considerShouldPass()){
    lookAround(true);
    return;
  }    


  // prepare for pass  
  if(fabs(ball->getPosition().getY())>15 && ball->getPosition().getX()>44){
    if (worldModel->isAttacked(worldModel->myself)){
      skillPool->kickAway();      
      lookAround(true); 
      return;
    }    
    
    if(skillPool->turnWithBallTo((Vector2D(42,0)-
				  myself->getPosition()).getDirection() ) )
      ;//go On
    else{
      skillPool->faceOnlyNeckToPoint(Vector2D(40,0));    
       return;
    }
  }
  
  if (considerDribbling()){
    currentlyDribbling = true;
    lookAround(false);
    return;
  }
  
  if (isStopBallNeeded()){
    skillPool->stopBall();
    lookAround(true);
    return;
  }
  
  skillPool->holdBall();
  lookAround(false);
  return;

}












