/******************************************************************************
 * Configuration.cc
 * Copyright (c) 2001 Virtual Werder
 *
 * implements:
 *   class Configuration
 *
 * requires:
 *
 *
 * Created on: 25.03.2001 by wenns
 * Maintainer: wenns
 * Group:
 * Co-authors:
 *
 * Changelog:
 *
 *****************************************************************************/

#include "Configuration.hh"
#include <iostream>

int Configuration::catchBanCycle;
int Configuration::clangAdviceWin;
int Configuration::clangDefineWin;
int Configuration::clangDelWin;
int Configuration::clangInfoWin;
int Configuration::clangMessDelay;
int Configuration::clangMessPerCycle;
int Configuration::clangMetaWin;
int Configuration::clangRuleWin;
int Configuration::clangWinSize;
int Configuration::coachPort;
int Configuration::dropBallTime;
int Configuration::freeformSendPeriod;
int Configuration::freeformWaitPeriod;
int Configuration::gameLogCompression;
int Configuration::gameLogVersion;
int Configuration::goalieMaxMoves;
int Configuration::halfTime;
int Configuration::hearDecay;
int Configuration::hearInc;
int Configuration::hearMax;
int Configuration::maxGoalKicks;
int Configuration::olcoachPort;
int Configuration::pointToBan;
int Configuration::pointToDuration;
int Configuration::port;
int Configuration::recvStep;
int Configuration::sayCoachCntMax;
int Configuration::sayCoachMsgSize;
int Configuration::sayMsgSize;
int Configuration::sendStep = 150;
int Configuration::sendViStep;
int Configuration::senseBodyStep = 100;
int Configuration::simulatorStep = 100;
int Configuration::slowDownFactor = 1;
int Configuration::startGoalL;
int Configuration::startGoalR;
int Configuration::synchMicroSleep;
int Configuration::synchOffset;
int Configuration::tackleCycles;
int Configuration::textLogCompression;
char Configuration::gameLogDir      [ gameLogDir_Len       ];
char Configuration::gameLogFixedName[ gameLogFixedName_Len ];
char Configuration::landmarkFile    [ landmarkFile_Len     ];
char Configuration::logDateFormat   [ logDateFormat_Len    ];
char Configuration::textLogDir      [ textLogDir_Len       ];
char Configuration::textLogFixedName[ textLogFixedName_Len ];
bool Configuration::coach;
bool Configuration::coachWReferee;
bool Configuration::oldCoachHear;
bool Configuration::windNone;
float Configuration::windRandom;
bool Configuration::backPasses;
bool Configuration::forbidKickOffOffside;
bool Configuration::freeKickFaults;
bool Configuration::fullstateL;
bool Configuration::fullstateR;
bool Configuration::gameLogDated;
bool Configuration::gameLogFixed;
bool Configuration::gameLogging;
bool Configuration::logTimes;
bool Configuration::profile;
bool Configuration::properGoalKicks;
bool Configuration::recordMessages;
bool Configuration::sendComms;
bool Configuration::synchMode;
bool Configuration::teamActuatorNoise;
bool Configuration::textLogDated;
bool Configuration::textLogFixed;
bool Configuration::textLogging;
bool Configuration::useOffside;
bool Configuration::verbose;
float Configuration::audioCutDist;
float Configuration::ballAccelMax;
float Configuration::ballDecay;
float Configuration::ballRand;
float Configuration::ballSize;
float Configuration::ballSpeedMax;
float Configuration::ballWeight;
float Configuration::catchProbability;
float Configuration::catchableAreaL = 2.0f;
float Configuration::catchableAreaW = 1.0f;
float Configuration::ckickMargin = 1.0f;
float Configuration::controlRadius = 2.0f;
float Configuration::dashPowerRate = 0.006f;
float Configuration::effortDec;
float Configuration::effortDecThr;
float Configuration::effortInc;
float Configuration::effortIncThr;
float Configuration::effortInit;
float Configuration::effortMin;
float Configuration::goalWidth = 14.02f;
float Configuration::inertiaMoment = 5.0f;
float Configuration::kickPowerRate;
float Configuration::kickRand;
float Configuration::kickRandFactorL;
float Configuration::kickRandFactorR;
float Configuration::kickableMargin;
float Configuration::maxmoment;
float Configuration::maxneckang;
float Configuration::maxneckmoment;
float Configuration::maxpower;
float Configuration::minmoment;
float Configuration::minneckang;
float Configuration::minneckmoment;
float Configuration::minpower;
float Configuration::offsideActiveAreaSize;
float Configuration::offsideKickMargin;
float Configuration::playerAccelMax;
float Configuration::playerDecay;
float Configuration::playerRand;
float Configuration::playerSize;
float Configuration::playerSpeedMax;
float Configuration::playerWeight;
float Configuration::prandFactorL;
float Configuration::prandFactorR;
float Configuration::quantizeStep;
float Configuration::quantizeStepL;
float Configuration::recoverDec;
float Configuration::recoverDecThr;
float Configuration::recoverMin;
float Configuration::slownessOnTopForLeftTeam;
float Configuration::slownessOnTopForRightTeam;
float Configuration::staminaIncMax;
float Configuration::staminaMax;
float Configuration::stoppedBallVel;
float Configuration::tackleBackDist;
float Configuration::tackleDist;
float Configuration::tackleExponent;
float Configuration::tacklePowerRate;
float Configuration::tackleWidth;
float Configuration::visibleAngle;
float Configuration::visibleDistance;
float Configuration::windAng;
float Configuration::windDir;
float Configuration::windForce;
float Configuration::windRand;


//------------------------   Player Parameter  -------------------------
int Configuration::playerTypes;
int Configuration::ptMax;
float Configuration::randomSeed;
int Configuration::subsMax;
float Configuration::dashPowerRateDeltaMax;
float Configuration::dashPowerRateDeltaMin;
float Configuration::effortMaxDeltaFactor;
float Configuration::effortMinDeltaFactor;
float Configuration::extraStaminaDeltaMax;
float Configuration::extraStaminaDeltaMin;
float Configuration::inertiaMomentDeltaFactor;
float Configuration::kickRandDeltaFactor;
float Configuration::kickableMarginDeltaMax;
float Configuration::kickableMarginDeltaMin;
float Configuration::newDashPowerRateDeltaMax;
float Configuration::newDashPowerRateDeltaMin;
float Configuration::newStaminaIncMaxDeltaFactor;
float Configuration::playerDecayDeltaMax;
float Configuration::playerDecayDeltaMin;
float Configuration::playerSizeDeltaFactor;
float Configuration::playerSpeedMaxDeltaMax;
float Configuration::playerSpeedMaxDeltaMin;
float Configuration::staminaIncMaxDeltaFactor;


vector<Sense::PlayerType> Configuration::playerTypesV;
Sense::PlayerType Configuration::playerTypesA[7];

Configuration::Configuration(){
}


Configuration::~Configuration(){
}


void Configuration::integrateServerParam(const Sense::ServerParam& serverParam){
  catchBanCycle =             serverParam.getCatchBanCycle();
  clangAdviceWin =            serverParam.getClangAdviceWin();
  clangDefineWin =            serverParam.getClangDefineWin();
  clangDelWin =               serverParam.getClangDelWin();
  clangInfoWin =              serverParam.getClangInfoWin();
  clangMessDelay =            serverParam.getClangMessDelay();
  clangMessPerCycle =         serverParam.getClangMessPerCycle();
  clangMetaWin =              serverParam.getClangMetaWin();
  clangRuleWin =              serverParam.getClangRuleWin();
  clangWinSize =              serverParam.getClangWinSize();
  coachPort =                 serverParam.getCoachPort();
  dropBallTime =              serverParam.getDropBallTime();
  freeformSendPeriod =        serverParam.getFreeformSendPeriod();
  freeformWaitPeriod =        serverParam.getFreeformWaitPeriod();
  gameLogCompression =        serverParam.getGameLogCompression();
  gameLogVersion =            serverParam.getGameLogVersion();
  goalieMaxMoves =            serverParam.getGoalieMaxMoves();
  halfTime =                  serverParam.getHalfTime();
  hearDecay =                 serverParam.getHearDecay();
  hearInc =                   serverParam.getHearInc();
  hearMax =                   serverParam.getHearMax();
  maxGoalKicks =              serverParam.getMaxGoalKicks();
  olcoachPort =               serverParam.getOlcoachPort();
  pointToBan =                serverParam.getPointToBan();
  pointToDuration =           serverParam.getPointToDuration();
  port =                      serverParam.getPort();
  recvStep =                  serverParam.getRecvStep();
  sayCoachCntMax =            serverParam.getSayCoachCntMax();
  sayCoachMsgSize =           serverParam.getSayCoachMsgSize();
  sayMsgSize =                serverParam.getSayMsgSize();
  sendStep =                  serverParam.getSendStep();
  sendViStep =                serverParam.getSendViStep();
  senseBodyStep =             serverParam.getSenseBodyStep();
  simulatorStep =             serverParam.getSimulatorStep();
  slowDownFactor =            serverParam.getSlowDownFactor();
  startGoalL =                serverParam.getStartGoalL();
  startGoalR =                serverParam.getStartGoalR();
  synchMicroSleep =           serverParam.getSynchMicroSleep();
  synchOffset =               serverParam.getSynchOffset();
  tackleCycles =              serverParam.getTackleCycles();
  textLogCompression =        serverParam.getTextLogCompression();
  strncpy(gameLogDir,       serverParam.getGameLogDir(),       gameLogDir_Len);
  strncpy(gameLogFixedName, serverParam.getGameLogFixedName(), gameLogFixedName_Len);
  strncpy(landmarkFile,     serverParam.getLandmarkFile(),     landmarkFile_Len);
  strncpy(logDateFormat,    serverParam.getLogDateFormat(),    logDateFormat_Len);
  strncpy(textLogDir,       serverParam.getTextLogDir(),       textLogDir_Len);
  strncpy(textLogFixedName, serverParam.getTextLogFixedName(), textLogFixedName_Len);
  coach =                     serverParam.getCoach();
  coachWReferee =             serverParam.getCoachWReferee();
  oldCoachHear =              serverParam.getOldCoachHear();
  windNone =                  serverParam.getWindNone();
  windRandom =                serverParam.getWindRandom();
  backPasses =                serverParam.getBackPasses();
  forbidKickOffOffside =      serverParam.getForbidKickOffOffside();
  freeKickFaults =            serverParam.getFreeKickFaults();
  fullstateL =                serverParam.getFullstateL();
  fullstateR =                serverParam.getFullstateR();
  gameLogDated =              serverParam.getGameLogDated();
  gameLogFixed =              serverParam.getGameLogFixed();
  gameLogging =               serverParam.getGameLogging();
  logTimes =                  serverParam.getLogTimes();
  profile =                   serverParam.getProfile();
  properGoalKicks =           serverParam.getProperGoalKicks();
  recordMessages =            serverParam.getRecordMessages();
  sendComms =                 serverParam.getSendComms();
  synchMode =                 serverParam.getSynchMode();
  teamActuatorNoise =         serverParam.getTeamActuatorNoise();
  textLogDated =              serverParam.getTextLogDated();
  textLogFixed =              serverParam.getTextLogFixed();
  textLogging =               serverParam.getTextLogging();
  useOffside =                serverParam.getUseOffside();
  verbose =                   serverParam.getVerbose();
  audioCutDist =              serverParam.getAudioCutDist();
  ballAccelMax =              serverParam.getBallAccelMax();
  ballDecay =                 serverParam.getBallDecay();
  ballRand =                  serverParam.getBallRand();
  ballSize =                  serverParam.getBallSize();
  ballSpeedMax =              serverParam.getBallSpeedMax();
  ballWeight =                serverParam.getBallWeight();
  catchProbability =          serverParam.getCatchProbability();
  catchableAreaL =            serverParam.getCatchableAreaL();
  catchableAreaW =            serverParam.getCatchableAreaW();
  ckickMargin =               serverParam.getCkickMargin();
  controlRadius =             serverParam.getControlRadius();
  dashPowerRate =             serverParam.getDashPowerRate();
  effortDec =                 serverParam.getEffortDec();
  effortDecThr =              serverParam.getEffortDecThr();
  effortInc =                 serverParam.getEffortInc();
  effortIncThr =              serverParam.getEffortIncThr();
  effortInit =                serverParam.getEffortInit();
  effortMin =                 serverParam.getEffortMin();
  goalWidth =                 serverParam.getGoalWidth();
  inertiaMoment =             serverParam.getInertiaMoment();
  kickPowerRate =             serverParam.getKickPowerRate();
  kickRand =                  serverParam.getKickRand();
  kickRandFactorL =           serverParam.getKickRandFactorL();
  kickRandFactorR =           serverParam.getKickRandFactorR();
  kickableMargin =            serverParam.getKickableMargin();
  maxmoment =                 serverParam.getMaxmoment();
  maxneckang =                serverParam.getMaxneckang();
  maxneckmoment =             serverParam.getMaxneckmoment();
  maxpower =                  serverParam.getMaxpower();
  minmoment =                 serverParam.getMinmoment();
  minneckang =                serverParam.getMinneckang();
  minneckmoment =             serverParam.getMinneckmoment();
  minpower =                  serverParam.getMinpower();
  offsideActiveAreaSize =     serverParam.getOffsideActiveAreaSize();
  offsideKickMargin =         serverParam.getOffsideKickMargin();
  playerAccelMax =            serverParam.getPlayerAccelMax();
  playerDecay =               serverParam.getPlayerDecay();
  playerRand =                serverParam.getPlayerRand();
  playerSize =                serverParam.getPlayerSize();
  playerSpeedMax =            serverParam.getPlayerSpeedMax();
  playerWeight =              serverParam.getPlayerWeight();
  prandFactorL =              serverParam.getPrandFactorL();
  prandFactorR =              serverParam.getPrandFactorR();
  quantizeStep =              serverParam.getQuantizeStep();
  quantizeStepL =             serverParam.getQuantizeStepL();
  recoverDec =                serverParam.getRecoverDec();
  recoverDecThr =             serverParam.getRecoverDecThr();
  recoverMin =                serverParam.getRecoverMin();
  slownessOnTopForLeftTeam =  serverParam.getSlownessOnTopForLeftTeam();
  slownessOnTopForRightTeam = serverParam.getSlownessOnTopForRightTeam()  ;
  staminaIncMax =             serverParam.getStaminaIncMax();
  staminaMax =                serverParam.getStaminaMax();
  stoppedBallVel =            serverParam.getStoppedBallVel();
  tackleBackDist =            serverParam.getTackleBackDist();
  tackleDist =                serverParam.getTackleDist();
  tackleExponent =            serverParam.getTackleExponent();
  tacklePowerRate =           serverParam.getTacklePowerRate();
  tackleWidth =               serverParam.getTackleWidth();
  visibleAngle =              serverParam.getVisibleAngle();
  visibleDistance =           serverParam.getVisibleDistance();
  windAng =                   serverParam.getWindAng();
  windDir =                   serverParam.getWindDir();
  windForce =                 serverParam.getWindForce();
  windRand =                  serverParam.getWindRand();
}


void Configuration::integratePlayerParam(const Sense::PlayerParam& playerParam){
  //playerTypesA = new Sense::PlayerType[playerParam.getPlayerTypes()+2];


  playerTypes =                 playerParam.getPlayerTypes();
  ptMax =                       playerParam.getPtMax();
  randomSeed =                  playerParam.getRandomSeed();
  subsMax =                     playerParam.getSubsMax();
  dashPowerRateDeltaMax =       playerParam.getDashPowerRateDeltaMax();
  dashPowerRateDeltaMin =       playerParam.getDashPowerRateDeltaMin();
  effortMaxDeltaFactor =        playerParam.getEffortMaxDeltaFactor();
  effortMinDeltaFactor =        playerParam.getEffortMinDeltaFactor();
  extraStaminaDeltaMax =        playerParam.getExtraStaminaDeltaMax();
  extraStaminaDeltaMin =        playerParam.getExtraStaminaDeltaMin();
  inertiaMomentDeltaFactor =    playerParam.getInertiaMomentDeltaFactor();
  kickRandDeltaFactor =         playerParam.getKickRandDeltaFactor();
  kickableMarginDeltaMax =      playerParam.getKickableMarginDeltaMax();
  kickableMarginDeltaMin =      playerParam.getKickableMarginDeltaMin();
  newDashPowerRateDeltaMax =    playerParam.getNewDashPowerRateDeltaMax();
  newDashPowerRateDeltaMin =    playerParam.getNewDashPowerRateDeltaMin();
  newStaminaIncMaxDeltaFactor = playerParam.getNewStaminaIncMaxDeltaFactor();
  playerDecayDeltaMax =         playerParam.getPlayerDecayDeltaMax();
  playerDecayDeltaMin =         playerParam.getPlayerDecayDeltaMin();
  playerSizeDeltaFactor =       playerParam.getPlayerSizeDeltaFactor();
  playerSpeedMaxDeltaMax =      playerParam.getPlayerSpeedMaxDeltaMax();
  playerSpeedMaxDeltaMin =      playerParam.getPlayerSpeedMaxDeltaMin();
  staminaIncMaxDeltaFactor =    playerParam.getStaminaIncMaxDeltaFactor();
}


void Configuration::printServerParam(){
  cout << catchBanCycle << " " << clangAdviceWin << " " << clangDefineWin << " " <<
    clangDelWin << " " << clangInfoWin << " " << clangMessDelay << " " <<
    clangMessPerCycle << " " << clangMetaWin << " " << clangRuleWin << " " <<
    clangWinSize << " " << coachPort << " " << dropBallTime << " " <<
    freeformSendPeriod << " " << freeformWaitPeriod << " " <<
    gameLogCompression << " " << gameLogVersion << " " << goalieMaxMoves << " " <<
    halfTime << " " << hearDecay << " " << hearInc << " " << hearMax << " " <<
    maxGoalKicks << " " << olcoachPort << " " << pointToBan << " " <<
    pointToDuration << " " << port << " " << recvStep << " " <<
    sayCoachCntMax << " " << sayCoachMsgSize << " " << sayMsgSize << " " <<
    sendStep << " " << sendViStep << " " << senseBodyStep << " " <<
    simulatorStep << " " << slowDownFactor << " " << startGoalL << " " <<
    startGoalR << " " << synchMicroSleep << " " << synchOffset << " " <<
    tackleCycles << " " << textLogCompression << " " << gameLogDir << " " <<
    gameLogFixedName << " " << landmarkFile << " " << logDateFormat << " " <<
    textLogDir << " " << textLogFixedName << " " << coach << " " <<
    coachWReferee << " " << oldCoachHear << " " << windNone << " " <<
    windRandom << " " << backPasses << " " << forbidKickOffOffside << " " <<
    freeKickFaults << " " << fullstateL << " " << fullstateR << " " <<
    gameLogDated << " " << gameLogFixed << " " << gameLogging << " " <<
    logTimes << " " << profile << " " << properGoalKicks << " " <<
    recordMessages << " " << sendComms << " " << synchMode << " " <<
    teamActuatorNoise << " " << textLogDated << " " << textLogFixed << " " <<
    textLogging << " " << useOffside << " " << verbose << " " <<
    audioCutDist << " " << ballAccelMax << " " << ballDecay << " " <<
    ballRand << " " << ballSize << " " << ballSpeedMax << " " << ballWeight << " " <<
    catchProbability << " " << catchableAreaL << " " << catchableAreaW << " " <<
    ckickMargin << " " << controlRadius << " " << dashPowerRate << " " <<
    effortDec << " " << effortDecThr << " " << effortInc << " " <<
    effortIncThr << " " << effortInit << " " << effortMin << " " <<
    goalWidth << " " << inertiaMoment << " " << kickPowerRate << " " <<
    kickRand << " " << kickRandFactorL << " " << kickRandFactorR << " " <<
    kickableMargin << " " << maxmoment << " " << maxneckang << " " <<
    maxneckmoment << " " << maxpower << " " << minmoment << " " <<
    minneckang << " " << minneckmoment << " " << minpower << " " <<
    offsideActiveAreaSize << " " << offsideKickMargin << " " <<
    playerAccelMax << " " << playerDecay << " " << playerRand << " " <<
    playerSize << " " << playerSpeedMax << " " << playerWeight << " " <<
    prandFactorL << " " << prandFactorR << " " << quantizeStep << " " <<
    quantizeStepL << " " << recoverDec << " " << recoverDecThr << " " <<
    recoverMin << " " << slownessOnTopForLeftTeam << " " <<
    slownessOnTopForRightTeam << " " << staminaIncMax << " " << staminaMax << " " <<
    stoppedBallVel << " " << tackleBackDist << " " << tackleDist << " " <<
    tackleExponent << " " << tacklePowerRate << " " << tackleWidth << " " <<
    visibleAngle << " " << visibleDistance << " " << windAng << " " <<
    windDir << " " << windForce << " " << windRand << " " << endl;
}

void Configuration::printPlayerParam(){
  cout << playerTypes << " " << ptMax << " " << randomSeed << " " <<
    subsMax << " " << dashPowerRateDeltaMax << " " << dashPowerRateDeltaMin << " " <<
    effortMaxDeltaFactor << " " << effortMinDeltaFactor << " " <<
    extraStaminaDeltaMax << " " << extraStaminaDeltaMin << " " <<
    inertiaMomentDeltaFactor << " " <<  kickRandDeltaFactor << " " <<
    kickableMarginDeltaMax << " " << kickableMarginDeltaMin << " " <<
    newDashPowerRateDeltaMax << " " << newDashPowerRateDeltaMin << " " <<
    newStaminaIncMaxDeltaFactor << " " << playerDecayDeltaMax << " " <<
    playerDecayDeltaMin << " " << playerSizeDeltaFactor << " " <<
    playerSpeedMaxDeltaMax << " " << playerSpeedMaxDeltaMin << " " <<
    staminaIncMaxDeltaFactor << endl;
}


void Configuration::addPlayerType(const Sense::PlayerType &type){
  // use both, dont ask why, just do it
  playerTypesV.push_back(type);
  playerTypesA[type.getTypeId()] = type;
  //DEBUG2_HARLEKIN("PlayerType added. ID: ", type.getTypeId());
}

Sense::PlayerType *Configuration::getPlayerType(int pT){
  return &(playerTypesA[pT]);
  /*
  vector<Sense::PlayerType>::iterator i;
  for(i = playerTypesV.begin(); i!=playerTypesV.end(); ++i){
    if(i->getTypeId() == pT)
      return &(*i);
  }
  return &(playerTypesV.front());
  */
}

float Configuration::getPlayerSpeedMax(int pT){
  if (!playerTypesV.empty()){
    Sense::PlayerType *playerType = getPlayerType(pT);
    return playerType->getPlayerSpeedMax();
  }else{
    return playerSpeedMax;
  }
}
float Configuration::getStaminaIncMax(int pT){
  if (!playerTypesV.empty()){
    Sense::PlayerType *playerType = getPlayerType(pT);
    return playerType->getStaminaIncMax();
  }else{
    return staminaIncMax;
  }
}
float Configuration::getStaminaMax(int pT){
  // unused parameter
  if (pT == pT) ;
  return /*getExtraStamina(pT) +*/ staminaMax;
}
float Configuration::getPlayerDecay(int pT){
  if (!playerTypesV.empty()){
    Sense::PlayerType *playerType = getPlayerType(pT);
    return playerType->getPlayerDecay();
  }else{
    return playerDecay;
  }
}
float Configuration::getInertiaMoment(int pT){
  if (!playerTypesV.empty()){
    Sense::PlayerType *playerType = getPlayerType(pT);
    return playerType->getInertiaMoment();
  }else{
    return inertiaMoment;
  }
}
float Configuration::getDashPowerRate(int pT){
  if (!playerTypesV.empty()){
    Sense::PlayerType *playerType = getPlayerType(pT);
    return playerType->getDashPowerRate();
  }else{
    return dashPowerRate;
  }
}
float Configuration::getPlayerSize(int pT){
  if (!playerTypesV.empty()){
    Sense::PlayerType *playerType = getPlayerType(pT);
    return playerType->getPlayerSize();
  }else{
    return playerSize;
  }
}
float Configuration::getKickableMargin(int pT){
  if (!playerTypesV.empty()){
    Sense::PlayerType *playerType = getPlayerType(pT);
    return playerType->getKickableMargin();
  }else{
    return kickableMargin;
  }
}
float Configuration::getKickRand(int pT){
  if (!playerTypesV.empty()){
    Sense::PlayerType *playerType = getPlayerType(pT);
    return playerType->getKickRand();
  }else{
    return kickRand;
  }
}
float Configuration::getExtraStamina(int pT){
  if (!playerTypesV.empty()){
    Sense::PlayerType *playerType = getPlayerType(pT);
    return playerType->getExtraStamina();
  }else{
    return 0; //extraStamina;
  }
}
float Configuration::getEffortMax(int pT){
  if (!playerTypesV.empty()){
    Sense::PlayerType *playerType = getPlayerType(pT);
    return playerType->getEffortMax();
  }else{
    return 1; //effortMax;
  }
}
float Configuration::getEffortMin(int pT){
  if (!playerTypesV.empty()){
    Sense::PlayerType *playerType = getPlayerType(pT);
    return playerType->getEffortMin();
  }else{
    return effortMin;
  }
}

float Configuration::getMaximumPlayerSpeed(int pT){
  if (!playerTypesV.empty()){
    Sense::PlayerType *playerType = getPlayerType(pT);
    return playerType->getActualPlayerSpeedMax();
  }else{
    return playerSpeedMax;
  }
}


void Configuration::printPlayerTypes(){
  for(int j = 0; j < playerTypes; j++){
    Sense::PlayerType *i = getPlayerType(j); //playerTypesA[j]; 
    DEBUG2_HARLEKIN("\nPlayerType: ",       i->getTypeId());
    DEBUG2_HARLEKIN(" PlayerSpeedMax: ",    i->getPlayerSpeedMax());
    DEBUG2_HARLEKIN(" ActPlayerSpeedMax: ", i->getActualPlayerSpeedMax());
    DEBUG2_HARLEKIN(" StaminaIncMax: ",     i->getStaminaIncMax());
    DEBUG2_HARLEKIN(" PlayerDecay: ",       i->getPlayerDecay());
    DEBUG2_HARLEKIN(" InertiaMoment: ",     i->getInertiaMoment());
    DEBUG2_HARLEKIN(" DashPowerRate: ",     i->getDashPowerRate());
    DEBUG2_HARLEKIN(" PlayerSize: ",        i->getPlayerSize());
    DEBUG2_HARLEKIN(" KickableMargin: ",    i->getKickableMargin());
    DEBUG2_HARLEKIN(" KickRand: ",          i->getKickRand());
    DEBUG2_HARLEKIN(" ExtraStamina: ",      i->getExtraStamina());
    DEBUG2_HARLEKIN(" EffortMax: ",         i->getEffortMax());
    DEBUG2_HARLEKIN(" EffortMin: ",         i->getEffortMin());    
  }
    //cout << *i << endl;
}
