/******************************************************************************
 * PotentialField.hh
 * Copyright (c) 2003 Virtual Werder
 *
 *
 * implements:
 *   class PotentialField
 *
 * requires:
 *
 *
 * Created on: 07.03.2003 by tekgeist
 * Maintainer:
 * Group:
 * Co-authors:
 *
 * Changelog:
 *
 *****************************************************************************/

#ifndef POTENTIALFIELD_HH
#define POTENTIALFIELD_HH 

#include "Geometry.hh"
#include "Configuration.hh"
#include "common.hh"
#include "debug.hh"

/**
 * The class PotentialField contains the potential field of the playfield
 */

class PotentialField{
public:
   PotentialField();
   virtual ~PotentialField();

/******** The Potential Functions of Game Objects ********/
   
   float playFieldBorderPotential      (const Vector2D pos);
   float theirGoalLogisticPotential    (const Vector2D pos);
   float ourGoalLogisticPotential      (const Vector2D pos);
   float theirPlayerGaussPotential     (const Vector2D pos);
   float ourPlayerGaussPotential       (const Vector2D pos);

/******** The Derivatives of the Potential Functions ********/
   
   void playFieldBorderGradient    (const Vector2D pos, Vector2D &gradient);
   void theirGoalLogisticGradient  (const Vector2D pos, Vector2D &gradient);
   void ourGoalLogisticGradient    (const Vector2D pos, Vector2D &gradient);
   void theirPlayerGaussGradient   (const Vector2D pos, Vector2D &gradient);
   void ourPlayerGaussGradient     (const Vector2D pos, Vector2D &gradient);

private:
   /*
    * dont change these... ;)
    */
   static const float Pi              = 3.141;
   static const float LENGTH          = 105;
   static const float WIDTH           = 68;
   /*
    * change those...
    * maybe.. ;)
    */
   static const float THEIRGOAL_SIGMA = 20;
   static const float OURGOAL_SIGMA   = 20;
   static const float ENEMY_A         = 2;
   static const float ENEMY_SIGMA     = 2;
   static const float TEAMMATE_A      = 2;
   static const float TEAMMATE_SIGMA  = 2;
   
};

#endif //POTENTIALFIELD_HH
