/******************************************************************************
 * Team.hh
 * Copyright (c) 2001 Virtual Werder
 *
 * implements:
 *   class Team
 *
 * requires:
 *
 *
 * Created on: 22.08.2001 by wenns
 * Maintainer: wenns
 * Group:
 * Co-authors:
 *
 * Changelog:
 *
 ******************************************************************************/

#ifndef TEAM_HH
#define TEAM_HH

#include "Player.hh"
#include <string.h>

#include <vector>

/**
 * Represents a Robocup simulation legue team and contains a number of players
 * and all available information about the team.
 */
class Team{
  private:
    static const int TEAM_SIZE = 11;     /** number of players in a team */

    char name[32];                       /**< the name of the team */
  
    /**
     * The players that are recognized as belonging to this team. The number
     * of them can vary.
     */
  vector<Player> players;

  public:
    Team();
    virtual ~Team();


    /** \name Accessors */
    //@{
    void setName(const char *n) { strcpy(name, n); }
    const char * getName() const { return name; }
    vector<Player> & getPlayers() { return players; }
    const Player * getGoalie() const;
    //@}


    /** prints the values of the data members on a string stream */
    friend ostream& operator<< (ostream &os, const Team &t){
      os << "name: " << t.name << endl;
      os << "players: " << endl;
      int playerCount = t.players.size();
      os << playerCount << endl;
      for(int i = 0; i < playerCount; i++)
        os << t.players[i] << endl;
      os << endl;
      return os;
    }
};

#endif //TEAM_HH

